C     Last change:  SC    5 Mar 2004   12:49 pm
C=======================================================================
C
      SUBROUTINE UNC1NLI1DF(IUUNC,IUNC,IINT,IIB,NHI,NQI,NPI,NOINT,IDIF,
     &                      ISGN,ITYP,NIB,IOIN,IDSQ,ITPR,IMAN,BDEL,
     &                      BDEL0,TOLDSQ,LCNLIP,LCWLIP,LCB2,LCBLIM,
     &                      LCDSQ,LCZ,LCCSV,NDRNI,NRIVI,NGHBI,
     &                      NSTRI,NCHDI,NDRTI,LCIDIN,IUNCRW,JMAN,
     &                      IBEY,BEYOND,LCNLJP,LCBS,IBS,IWRP,TOLP,TOLS,
     &                      TOLY,LCIDOB,NOBS,IACT,LCCFI)
C     VERSION 1001 08MAR2002 (SC)
C     ******************************************************************
C     INITIALIZE VARIABLES FOR UNCERTAINTY-ESTIMATION PROCESS
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INTEGER IUNC,IINT,IIB,NHI,NQI,NPI,NOINT,IDIF,ISGN,ITYP,NIB,NOBS,
     &        IOIN,IDSQ,ITPR,IMAN,LCNLIP,LCWLIP,LCB2,LCBLIM,JMAN,IACT,
     &        LCDSQ,LCZ,LCCSV,NDRNI,NRIVI,NGHBI,NSTRI,NCHDI,NDRTI,
     &        LCIDIN,IUUNC,IUNCRW,IBEY,LCNLJP,LCBS,IBS,IWRP,LCIDOB,LCCFI
      REAL BDEL,BDEL0,TOLDSQ,BEYOND,TOLP,TOLS,TOLY
C     ------------------------------------------------------------------
      WRITE(*,*)
C
C-----INITIALIZE GLOBAL VARIABLES THAT BELONG PRIMARILY TO THE 
C     UNCERTANTY-ESTIMATION PROCESS
      IUNC = 0
      IF (IUUNC.GT.0) IUNC = 1
      IACT = 0
      IUNCRW = 0
      IINT = 0
      IIB = 0
      NHI = 0
      NQI = 0
      NDRNI = 0
      NRIVI = 0
      NGHBI = 0
      NSTRI = 0
      NCHDI = 0
      NDRTI = 0
      NPI = 0
      NOINT = 0
      NOBS = 0
      IDIF = 0
      ISGN = 0
      ITYP = 1
      IBS = 0
      IWRP = 0
      NIB = 0
      IOIN = 0
      IDSQ = 0
      ITPR = 0
      IMAN = 0
      JMAN = 0
      IBEY = 0
      BDEL = 0.
      BDEL0 = 0.
      TOLDSQ = 0.
      TOLP = 0.
      TOLS = 0.
      TOLY = 0.
      BEYOND = 0.
C
C-----INITIALIZE POINTERS FOR ARRAYS
C
      LCNLIP = 1
      LCNLJP = 1
      LCWLIP = 1
      LCB2 = 1
      LCBS = 1
      LCBLIM = 1
C      LCHINI = 1
      LCDSQ = 1
C      LCU = 1
      LCZ = 1
      LCCSV = 1
      LCIDIN = 1
      LCIDOB = 1
      LCCFI = 1
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1AL(ISUMX,ISUMZ,ISUMIX,NPLIST,IOUTG,
     &                      NHI,NQI,NPI,NOINT,ISGN,ITYP,
     &                      NIB,IDSQ,IOIN,LCNLIP,LCWLIP,LCZ,LCB2,
     &                      LCCSV,NOPT,LCDSQ,ITPR,
     &                      IMAN,LCBLIM,IDIF,
     &                      IOBS,ISEN,IPES,IU,NDRNI,NRIVI,NGHBI,
     &                      NSTRI,NCHDI,NDRTI,IREWND,LCIDIN,
     &                      IBEFLG,IOSTAR,LCNLJP,LCBS,IBS,IWRP,TOLP,
     &                      TOLS,TOLY,LCIDOB,NOBS,NH,NQT,IACT,LCCFI,
     &                      IPAR,LASTX,IYCFLG,ITMXP,IPRINT,LPRINT)
C     VERSION 1001 08MAR2002 (SC)
C     ******************************************************************
C     ALLOCATE ARRAY STORAGE FOR THE UNCERTAINTY-ESTIMATION PROCESS
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      LOGICAL LOPEN
      INTEGER NPLIST,IOUTG,NHI,NQI,NPI,NOINT,LCIDIN,IERR,ISP,IDUM,
     &        ISGN,ITYP,NIB,IDSQ,IOIN,LCNLIP,LCWLIP,LCZ,LCB2,
     &        LCCSV,NOPT,LCDSQ,ITPR,IMAN,ISOLD,ISOLDI,ISOLDZ,NOBS,
     &        LCBLIM,IDIF,IOBS,ISEN,IPES,IU,ISUMX,ISUMZ,ISUMIX,
     &        NDRNI,NRIVI,NGHBI,NSTRI,NCHDI,NDRTI,N,IREWND,IOSTAR,
     &        LLOC,IBEG,IEND,LCNLJP,LCBS,IBS,IWRP,IBEFLG,LCIDOB,NH,NQT,
     &        IACT,LCCFI,IPAR,LASTX,IYCFLG,ITMXP,IPRINT,LPRINT
       REAL DUM,TOLP,TOLS,TOLY
C      REAL BDEL,BDEL0,TOLDSQ
      CHARACTER*200 LINE
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
  820 FORMAT(10I5)
  825 FORMAT(8F10.0)
  830 FORMAT(
     &' TOTAL NUMBER OF INTERVALS..............................:',I5,/,
     &' HEAD AND FLOW INTERVALS ON DIFFERENCES (0,1)=(NO,YES)..:',I5,/,
     &' INTERVAL LIMITS? (1=UPPER,-1=LOWER,O=UPPER & LOWER)....:',I5,/,
     &' INTERVAL TYPE (1=CONFIDENCE,2=PREDICTION)..............:',I5,/,
     &' NUMBER OF INITIAL PARAMETER SETS (0=USE DATASET 8).....:',I5,/,
     &' RESULT SUMMARY IS WRITTEN TO UNIT NO (1=NOT WRITTEN)...:',I5,/,
     &' CRITICAL VALUE CONST./VAR. (IDSQ=0/1)..................:',I5,/,
     &' PRINT ITERATION LOG (1=YES,ELSE=NO)....................:',I5,/,
     &' USE APPROXIMATE INCREMENTAL ADJUSTMENT? (1=YES,0=NO)...:',I5,/,
     &' WEIGHTED RESIDUALS ARE WRITTEN TO UNIT NO (O=NOT WRIT.):',I5,/,
     &' SCALING VALUES BS (1=READ VALUES, 0=COPY START. VAL.)..:',I5,/,
     &' TOLP (CONVERGENCE CRITERIA FOR PARAMETER CHANGE).......:',G13.6,
     &/,
     &' TOLS (CONV. CRIT. FOR CHANGE OF OBJECTIVE FUNCTION)....:',G13.6,
     &/,
     &' TOLY (CONV. CRIT. FOR CHANGE OF COMPUTED LIMIT VALUE)..:',G13.6)
  840 FORMAT(//,' ERROR! UNIT NO.',I5,' NOT OPENED (OUTPUT FILE FOR',A)
  880 FORMAT(//,' INTERVALS CANNOT BE CALCULATED BY QUASI-NEWTON METHOD
     :- THEREFORE IS SET NOPT=0')
  890 FORMAT (/,' UNC1NLI1 -- UNCERTAINTY-ESTIMATION PROCESS, ',
     &'VERSION 1.0, 03/08/02',/,' INPUT READ FROM UNIT ',I3)
  900 FORMAT(' ERROR! NHI MUST BE AN EQUAL NUMBER FOR IDIF=1; ',
     &       'INPUT IS NHI=',I5)
  910 FORMAT(
     &' NUMBER OF HEAD DIFFERENCE INTERVALS....................:',I5)
  920 FORMAT(
     &' NUMBER OF HEAD INTERVALS...............................:',I5)
  930 FORMAT(
     &' NUMBER OF PARAMETER INTERVALS..........................:',I5)
  940 FORMAT(' IACT=0: COMPUTE CONFIDENCE OR PREDICTION INTERVALS')
  941 FORMAT(' IACT=1: SET IBEFLG=1 TO GENERATE _b1 AND _b3 FILES FOR ',
     & 'BEALE2 PROGRAM')
  942 FORMAT(' IACT=2: SET IBEFLG=2 TO GENERATE _b2 AND _b4 FILES FOR ',
     & 'BEALE2 PROGRAM')
  943 FORMAT(' IACT=3: GENERATE CORFAC INPUT FILE')
  950 FORMAT (/,
     &' SEN AND PES PROCESSES ARE DEACTIVATED BECAUSE IACT =2,',
     &' IBEFLG = 2 -- ',/,
     &' SECOND INPUT FILE FOR BEALE2 WILL BE GENERATED')
C
      IREWND = 0
      IERR = 0
C
C------IDENTIFY PROCESS
      WRITE(IOUTG,890) IU
C
C-----CHECK IF OBSERVATION, SENSITIVITY AND PARAMETER-ESTIMATION
C     PROCESSES ARE ACTIVE
      IF (IOBS.LT.1) THEN
        WRITE(IOUTG,'(//,2A)') ' ERROR! ',
     &                        'OBSERVATION PROCESS MUST BE ACTIVATED!'
        IERR=1
      END IF
      IF (ISEN.LT.1) THEN
        WRITE(IOUTG,'(//,2A)') ' ERROR! ',
     &                        'SENSITIVITY PROCESS MUST BE ACTIVATED!'
        IERR=1
      END IF
      IF (IPES.LT.1) THEN
        WRITE(IOUTG,'(//,2A)') ' ERROR! ',
     &    ' PARAMETER-ESTIMATION PROCESS MUST BE ACTIVATED'
        IERR=1
      END IF
C
C-------READ, CHECK AND WRITE DATA
      CALL URDCOM(IU,IOUTG,LINE)
      LLOC = 1
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IACT,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,NPI,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IDIF,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,ISGN,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,ITYP,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,NIB,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IOIN,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IDSQ,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,ITPR,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IMAN,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IWRP,DUM,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,2,IBS,DUM,IOUTG,IU)
C      
      CALL URDCOM(IU,IOUTG,LINE)
      LLOC = 1
      CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,TOLP,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,TOLS,IOUTG,IU)
      CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,TOLY,IOUTG,IU)
C     
      IF (IACT.LT.0.OR.IACT.GT.3) IACT=0
      IBEFLG=IACT
      IF (IBEFLG.GT.2) IBEFLG=0
      IDUM=940+IACT
      SELECT CASE (IACT)
         CASE (1)
            WRITE(IOUTG,941)
         CASE (2)
            WRITE(IOUTG,942)
         CASE (3)
            WRITE(IOUTG,943)
         CASE DEFAULT
            WRITE(IOUTG,940)
      END SELECT
C-----IF IBEFLG = 2, DEACTIVATE SEN AND PES PROCESSES TO GENERATE
C     SECONDARY INPUT FILED (OUTNAM._b2 AND ._b4) FOR NLBEALE
      IF (IBEFLG.EQ.2) THEN
         ISEN = 0
         IPES = 0
         IPAR = -1
         LASTX = 0
         IYCFLG = -1
         ITMXP = 1
         IOSTAR = 0
         IPRINT = 0
         LPRINT = 0
         WRITE (IOUTG,950)
      ENDIF
C      
      IF (IDIF.NE.1) IDIF = 0
      IF (ISGN.LT.0) THEN
        ISGN = -1
      ELSE IF (ISGN.GT.0) THEN
        ISGN = 1
      ENDIF
      IF (ITYP.NE.2) ITYP = 1
      IF (NIB.LT.0)  NIB = 0
      IF (NOPT.NE.0) THEN
        IF (IOSTAR.NE.1) WRITE(*,880)
        WRITE(IOUTG,880)
        NOPT = 0
      ENDIF
      IF (IMAN.NE.0) THEN
        IWRP = 0
        IMAN = 1
      ENDIF
      IF (TOLP.LT.0.) TOLP=0.
      IF (TOLS.LT.0.) TOLS=0.
      IF (TOLY.LT.0.) TOLY=0.
      IF (TOLP.LT.1.E-12.AND.TOLS.LT.1.E-12.AND.TOLY.LT.1.E-12) THEN
        WRITE(IOUTG,'(//,2A)') ' ERROR! ',
     &    ' ALL CONVERGENCE CRITERIA (TOLP, TOLS, TOLY) ARE TOO SMALL'
        IERR = 1        
      END IF    
C
C     SET VARIABLES FOR HEAD INTERVALS
      IF (NHI.GT.0) THEN
        IF (IDIF.NE.0) THEN
          N = NHI/2
          IF (N+N.NE.NHI) THEN
            WRITE(IOUTG,900) NHI
            IERR = 1
          ELSE
            WRITE(IOUTG,910) N
          END IF
        ELSE
          WRITE(IOUTG,920) NHI
          N = NHI
        ENDIF
      ELSE
        NHI = 0
        N = NHI
      END IF
      NOINT = NOINT+N
C
C     SET VARIABLES FOR FLOW INTERVALS
      CALL SUNC1NLI1FI('DRN','NDRNI',NDRNI,NOINT,NQI,IDIF,IERR,IOUTG)
      CALL SUNC1NLI1FI('RIV','NRIVI',NRIVI,NOINT,NQI,IDIF,IERR,IOUTG)
      CALL SUNC1NLI1FI('GHB','NGHBI',NGHBI,NOINT,NQI,IDIF,IERR,IOUTG)
      CALL SUNC1NLI1FI('STR','NSTRI',NSTRI,NOINT,NQI,IDIF,IERR,IOUTG)
      CALL SUNC1NLI1FI('CHD','NCHDI',NCHDI,NOINT,NQI,IDIF,IERR,IOUTG)
      CALL SUNC1NLI1FI('DRT','NDRTI',NDRTI,NOINT,NQI,IDIF,IERR,IOUTG)
C
C     SET VARIABLES FOR PARAMETER INTERVALS
      IF (NPI.GT.0) THEN
        IF (NPI.GT.NPLIST) NPI = NPLIST
        WRITE(IOUTG,930) NPI
      ELSE
        IF (NPI.LT.0) NPI = 0
      END IF  
      NOINT = NOINT+NPI
C
      IF (IOIN.GT.1) THEN
         INQUIRE(IOIN,OPENED=LOPEN)
         IF (LOPEN) GO TO 90
         WRITE(IOUTG,840) IOIN,' SUMMARY OF COMPUTED INTERVALS)'
         WRITE(*,840) IOIN,' SUMMARY OF COMPUTED INTERVALS)'
         IERR=1
      ELSE
         IOIN=1
      END IF    
C
   90 IF (IWRP.GT.0) THEN
         INQUIRE(IWRP,OPENED=LOPEN)
         IF (LOPEN) GO TO 100
         WRITE(IOUTG,840) IWRP,' WEIGHTED RESIDUALS)'
         WRITE(*,840) IWRP,' WEIGHTED RESIDUALS)'
         IERR=1
      ELSE
         IWRP=0
      END IF    
C
  100 WRITE(IOUTG,830) NOINT,IDIF,ISGN,ITYP,NIB,IOIN,IDSQ,ITPR,IMAN,
     &                 IWRP,IBS,TOLP,TOLS,TOLY
      IF (NIB.LE.0) THEN
        NIB = 1
        IOIN = -IOIN
      ENDIF
      IF (IDIF.EQ.1) NOINT = NHI+NQI+NPI
C
C-------CHECK FOR ERRORS
      IF (IERR.GT.0) THEN
        WRITE(IOUTG,590)
        STOP ' ERRORS IN DEFINITION OF UNCERTAINTY INTERVALS'
      END IF
  590 FORMAT(' ERRORS IN DEFINITION OF UNCERTAINTY INTERVALS',/,
     &' LOOK ABOVE FOR ERROR!')
C
C-------STORE, IN ISOLD, LOCATION OF FIRST UNALLOCATED SPACE IN X.
      ISOLD = ISUMX
      ISOLDI = ISUMIX
      ISOLDZ = ISUMZ
C
C     ALLOCATE ARRAYS USED FOR UNCERTAINTY-ESTIMATION
      NOBS = NH+NQT-NHI-NQI
      LCNLIP = ISUMIX
      ISUMIX = ISUMIX+NPI
      LCNLJP = ISUMIX
      ISUMIX = ISUMIX+NPI
      LCIDIN = ISUMIX
      ISUMIX = ISUMIX+NOINT
      LCIDOB = ISUMIX
      ISUMIX = ISUMIX+NOBS
      LCWLIP = ISUMX
      ISUMX = ISUMX+NPI
      LCB2 = ISUMX
      ISUMX = ISUMX+NIB*NPLIST
      LCBS = ISUMX
      ISUMX = ISUMX+NPLIST
      LCBLIM = ISUMX
      ISUMX = ISUMX+NPLIST
      LCDSQ = ISUMX
      ISUMX = ISUMX+NOINT
      LCCFI = ISUMX
      ISUMX = ISUMX+NOINT
      LCZ = ISUMZ
      ISUMZ = ISUMZ+NPLIST
      LCCSV = ISUMZ
      ISUMZ = ISUMZ+NPLIST*NPLIST
C
C
C------PRINT AMOUNT OF SPACE USED BY PARAMETER-ESTIMATION PACKAGE.
      ISP = ISUMX - ISOLD
      WRITE (IOUTG,600) ISP
  600 FORMAT (/,1X,I6,
     &        ' ELEMENTS IN X ARRAY ARE USED FOR PARAMETER ESTIMATION')
      ISP = ISUMZ - ISOLDZ
      WRITE (IOUTG,610) ISP
  610 FORMAT (1X,I6,
     &        ' ELEMENTS IN Z ARRAY ARE USED FOR PARAMETER ESTIMATION')
      ISP = ISUMIX - ISOLDI
      WRITE (IOUTG,620) ISP
  620 FORMAT (1X,I6,
     &        ' ELEMENTS IN IX ARRAY ARE USED FOR PARAMETER ESTIMATION')
C
C------RETURN
      RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1RP(IU,NPLIST,NH,NQT,IOUTG,NHI,NQI,NPI,
     &                      NIB,ITYP,IOIN,NLIP,WLIP,B2,IBS,BS,NDER,
     &                      IQOB,NPOBS,NOINT,IDSQ,DSQ,IMAN,IDIF,
     &                      NPE,NDRNI,NRIVI,NGHBI,NSTRI,NCHDI,NDRTI,
     &                      LCOBDRN,LCOBRIV,LCOBGHB,LCOBSTR,LCOBCHD,
     &                      LCOBDRT,IDINT,NQTDR,NQTRV,NQTGB,NQTST,NQTCH,
     &                      NQTDT,BDEL,BDEL0,TOLDSQ,NLJP,LN,NOBS,IDOBS,
     &                      IBEFLG,CFR,CFI)
C     VERSION 1001 08MAR2002 (SC)
C     ******************************************************************
C     READ, CHECK AND STORE DATA FOR UNCERTAINTY ESTIMATION
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INTEGER NPE,NH,NQT,IU,IOUTG,NHI,NQI,NPI,NIB,ITYP,IOIN,NLJP,
     &        NPOBS,NOINT,IDSQ,IMAN,IDIF,NLIP,NDER,IQOB,NPLIST,IBS,
     &        NDRNI,NRIVI,NGHBI,NSTRI,NCHDI,NDRTI,LCOBDRN,LCOBRIV,LN,
     &        LCOBGHB,LCOBSTR,LCOBCHD,LCOBDRT,IDINT,NQTDT,NQTCH,NQTST,
     &        NQTGB,NQTRV,NQTDR,IERR,INC,I,J,N,IINT,LLOC,IBEG,IEND,IDUM,
     &        IOBS,NOBS,IDOBS,N0,IBEFLG
      REAL WLIP,B2,DSQ,WL,BDEL,BDEL0,TOLDSQ,CVLOG2LN,BS,CFR,CFI
      DIMENSION NLIP(NPI),WLIP(NPI),B2(NIB,NPLIST),NDER(5,NH),
     &          IQOB(NQT),DSQ(NOINT),IDINT(NOINT),NLJP(NPI),LN(NPLIST),
     &          BS(NPLIST),IDOBS(NOBS),CFI(NOINT)
      CHARACTER*10 PNAM,PNI,PNJ
      CHARACTER*200 LINE
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
   10 FORMAT(6I13)
   20 FORMAT(6F13.0)
   22 FORMAT(6(G11.5,2X))
   25 FORMAT(8F10.4)
   30 FORMAT(//,' PREDICTION INTERVAL TO BE CALCULATED FOR THE FOLLOWING
     & PARAMETERS',/,' PAR. NO    VARIANCE')
   35 FORMAT(//,' CONFIDENCE INTERVAL TO BE CALCULATED FOR THE FOLLOWING
     & PARAMETERS',/,' PAR. NO')
   40 FORMAT(3X,A10,E13.4)
   50 FORMAT(/,' ERROR! UNCERTAINTY INTERVAL CANNOT BE COMPUTED FOR',
     &' MANUALLY ADHUSTED PARAMETER ',A)
   55 FORMAT(//,' ERROR! THE CRITICAL VALUE (DSQ) CANNOT BE <= ZERO')
   56 FORMAT(//,' CRITICAL VALUE (DSQ) FOR INTERVALS')
   60 FORMAT(/,' ERROR! VARIANCE MULTIPLIER MUST BE GREATER THAN ZERO')
   65 FORMAT(//,' CORRECTION FACTOR FOR REGION (CFR): ',F10.4)
   66 fORMAT(/,' ERROR! CORRECTION FACTOR MUST BE GREATER THAN ZERO')
   67 FORMAT(//,' CORRECTION FACTORS FOR INTERVALS (CFI): ')
   70 FORMAT(' INITIAL PARAMETER SET NO.',I3,':')
   74 FORMAT(' SCALING VALUES FOR DAMPING PARAMETER CHANGES:')
   75 FORMAT (/,' ERROR! NUMBER OF PARAMETER INTERVALS EXCEEDS NUMBER ',
     &'OF ESTIMATED PARAMETERS: NPI=',I3,',',3X,'NPE=',I3,'.')
   76 FORMAT(
     &' INCREMENTAL ADJUSTMENT OF PARAMETER..................:',A,/,
     &' INCREMENT FOR PARAMETER ADJUSTMENT...................:',G13.6,/,
     &' RELATIVE SSQ EXCESS OF DSQ ACCEPTED FOR INC. ADJ.....:',G13.6,
     & //)
   77 FORMAT(//,' ERROR! BDEL MUST BE GREATER THAN ZERO!')
   78 FORMAT(//,' ERROR! TOLDSQ MUST BE GREATER THAN OR EQUAL TO ZERO!')
C
      IERR = 0
C
C-------CHECK NPI AND SET MANUALLY ADJUSTED PARAMETER
      IF (NPI.GT.NPE) THEN
         WRITE(IOUTG,75) NPI,NPE
         IERR = 1
      ENDIF
      IF (IMAN.NE.0) THEN
        IMAN = IPPTR(NPE)
        READ(IU,'(A)') LINE
        LLOC = 1
        CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,BDEL,IOUTG,IU)
        CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,TOLDSQ,IOUTG,IU)
        WRITE(IOUTG,76) PARNAM(IMAN),BDEL,TOLDSQ
        IF (BDEL.LE.0) THEN
          WRITE(IOUTG,77)
          IERR = 1
        ENDIF
        BDEL0 = BDEL
        IF (TOLDSQ.LT.0.) THEN
          WRITE(IOUTG,78)
          IERR=1
        ENDIF
        TOLDSQ = TOLDSQ+1.0
      ENDIF
C
C-------READ, WRITE AND CHECK CRITICAL VALUES FOR INTERVALS
      INC=1+IDIF
      IF (IDSQ.EQ.0) THEN
         READ(IU,'(A)') LINE
         LLOC = 1
         CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,DSQ(1),IOUTG,IU)
         IF (NOINT.GT.1) THEN
            DO 80 I=2,NOINT
               DSQ(I)=DSQ(1)
   80       CONTINUE
         ENDIF
      ELSE
         READ(IU,*)  (DSQ(I),I=1,NHI+NQI,INC),
     &               (DSQ(I),I=NHI+NQI+1,NOINT)
      ENDIF
      WRITE(IOUTG,56)
      WRITE(IOUTG,25) (DSQ(I),I=1,NHI+NQI,INC),(DSQ(I),I=NHI+NQI+1,
     &                                                   NOINT)
      DO 85 I=1,NOINT
        IF (DSQ(I).LT.0.) THEN
          WRITE(*,55)
          WRITE(IOUTG,55)
          IERR=1
        ENDIF
   85 CONTINUE
C
C-------DATA FOR CONFIDENCE INTERVALS ON PARAMETERS
      IF (NPI.GT.0) THEN
        IF (ITYP.EQ.2) THEN
          WRITE(IOUTG,30)
        ELSE
          WRITE(IOUTG,35)
          WL=1.
        ENDIF
        DO 88 I=1,NPI
          IF (ITYP.EQ.2) THEN
            READ(IU,*) PNAM,WL
          ELSE
            READ(IU,*) PNAM
          END IF
          CALL UCASE(PNAM,PNI,1)
          IF (IMAN.NE.0) THEN
            CALL UCASE(PARNAM(IMAN),PNJ,1)
            IF (PNI.EQ.PNJ) THEN
              WRITE(IOUTG,50) PARNAM(IMAN)
              IERR=1
            END IF
          ENDIF
          DO 87 J=1,NPE
            CALL UCASE(PARNAM(IPPTR(J)),PNJ,1)
            IF (PNI.EQ.PNJ) THEN
              NLIP(I)=IPPTR(J)
              NLJP(I)=J
              WLIP(I)=WL
              GOTO 88
            END IF
   87     CONTINUE
          WRITE(IOUTG,*) ' ERROR! PARAMETER ',PNAM, ' IS EITHER ',
     &                  ' UNDEFINED OR ISENS<1 IN SEN FILE'
          IERR=1
   88   CONTINUE
        CVLOG2LN=LOG(10.0)**2
        DO 90 I=1,NPI
          IF (ITYP.EQ.2) THEN
            WRITE(IOUTG,40) PARNAM(NLIP(I)), WLIP(I)
            IF (WLIP(I).LE.0.) THEN
              WRITE(IOUTG,60) 
              IERR=1
            ELSE
              IF (LN(NLIP(I)).GT.0) WLIP(I)=WLIP(I)*CVLOG2LN
            ENDIF
          ELSE
            WRITE(IOUTG,40) PARNAM(NLIP(I))
            WLIP(I)=0.
          ENDIF
   90   CONTINUE
      ENDIF
C
C-------INITIAL PARAMETERS FOR CONFIDENCE INTERVAL CALCULATION
      IF (IOIN.LT.0) THEN
        IOIN=-IOIN
        DO 100 J=1,NPLIST
          B2(1,J)=B(J)
  100   CONTINUE
      ELSE
        DO 110 I=1,NIB
          READ(IU,*) (B2(I,J), J=1,NPLIST)
          WRITE(IOUTG,70) I
          WRITE(IOUTG,22) (B2(I,J), J=1,NPLIST)
  110   CONTINUE
      ENDIF
C
C-------SCALING VALUES FOR DAMPING PARAMETER CHANGES
      IF (IBS.NE.0) THEN
          READ(IU,*) (BS(J), J=1,NPLIST)
      ELSE
        DO 120 J=1,NPLIST
          BS(J)=B(J)
  120   CONTINUE
      ENDIF
      WRITE(IOUTG,74)
      WRITE(IOUTG,22) (BS(J), J=1,NPLIST)
      DO 130 J=1,NPLIST
         IF (LN(J).GT.0) BS(J)=LOG(BS(J))
         IF (BS(J).EQ.0.0) BS(J)=1.0
  130 CONTINUE
C
C-------IF IBEFLG=1, READ AND WRITE CORRECTION FACTORS TO BE USED FOR 
C       GENERATING PARAMETER SETS USED TO GENERATE INPUT FOR BEALE2
      IF (IBEFLG.EQ.1) THEN
         READ(IU,'(A)') LINE
         LLOC = 1
         CALL URWORD(LINE,LLOC,IBEG,IEND,3,IDUM,CFR,IOUTG,IU)
         WRITE(IOUTG,65) CFR
         IF (CFR.LE.0.) THEN
            WRITE(*,66)
            WRITE(IOUTG,66)
            IERR=1
         ENDIF
         IF (NOINT.GT.0) THEN
            N=NOINT
            IF (IDIF.GT.0) N=NPI+(NHI+NQI)/2
            READ(IU,*) (CFI(I),I=1,N)
            WRITE(IOUTG,67)
            WRITE(IOUTG,25) (CFI(I),I=1,N)
            DO 140 I=1,N
               IF (CFI(I).LT.0.) THEN
                  WRITE(*,66)
                  WRITE(IOUTG,66)
                  IERR=1
               ENDIF
  140       CONTINUE
         ENDIF
      END IF   
  
C
C-------SET ID OF HEAD AND FLOW INTERVAL VARIABLES AND OBSERVATIONS
      IINT = 0
      IOBS = 0
      N0 = 1
      N = NH-NHI
      IF (NH.GT.0)
     $   CALL SUNC1NLI1ID(IINT,NOINT,N,NHI,IDINT,N0,IDOBS,NOBS,IOBS)
      N0 = N+1
      N = N+NQTDR-NDRNI
      IF (NQTDR.GT.0)
     $ 	CALL SUNC1NLI1ID(IINT,NOINT,N,NDRNI,IDINT,N0,IDOBS,NOBS,IOBS)
      N0 = N+1
      N = N+NQTRV-NRIVI
      IF (NQTRV.GT.0)
     $	CALL SUNC1NLI1ID(IINT,NOINT,N,NRIVI,IDINT,N0,IDOBS,NOBS,IOBS)
      N0 = N+1
      N = N+NQTGB-NGHBI
      IF (NQTGB.GT.0)
     $	CALL SUNC1NLI1ID(IINT,NOINT,N,NGHBI,IDINT,N0,IDOBS,NOBS,IOBS)
      N0 = N+1
      N = N+NQTST-NSTRI
      IF (NQTST.GT.0)
     $	CALL SUNC1NLI1ID(IINT,NOINT,N,NSTRI,IDINT,N0,IDOBS,NOBS,IOBS)
      N0 = N+1
      N = N+NQTCH-NCHDI
      IF (NQTCH.GT.0)
     $ 	CALL SUNC1NLI1ID(IINT,NOINT,N,NCHDI,IDINT,N0,IDOBS,NOBS,IOBS)
      N0 = N+1
      N = N+NQTDT-NDRTI
      IF (NQTDT.GT.0)
     $	CALL SUNC1NLI1ID(IINT,NOINT,N,NDRTI,IDINT,N0,IDOBS,NOBS,IOBS)
C
      IF (IERR.GT.0) STOP
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1LP(IINT,NOINT,IIB,NIB,ISGN,SGN,NPE,B2,
     &                      IOUTG,IOUT,ISTOP,NH,NQT,
     &                      NHI,NQI,IPRINT,LPRINT,IMAN,
     &                      JMAN,ITERM,ITRM1,BM1,LN,ISENS,BDEL,BDEL0,
     &                      SSEMAX,TOLDSQ,DSQ,IDIF,IDINT,IUNCRW,ITERPF,
     &                      ITERPK,IHDDFL,IFLD,IFO,ISA,JDRY,IDRY,DMX,
     &                      DMAX,AP,FAC,ADMX,FCONV,NPLIST,OBSNAM,
     &                      IOSTAR,IBEY,FLCNV,NPI,NLIP)
C-----VERSION 1001 05APR2002 (SC)
C     ******************************************************************
C     LOOP CONTROL FOR CALCULATION OF A SERIES OF CONFIDENCE  INTERVALS
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      CHARACTER*12 OBSNAM(NH+NQT)
      CHARACTER*10 DATE0,TIME0,DATE,TIME,ZONE
      INTEGER IINT,NOINT,IIB,NIB,ISGN,NPE,IOUT,ID,NLIP,NPI,
     &        ISTOP,NH,NQT,NHI,NQI,NPLIST,IVAL,IOUTG,IOSTAR,
     &        IPRINT,LPRINT,IDINT,IMAN,JMAN,ITERM,ITRM1,LN,ISENS,IBEY,
     &        IDIF,IUNCRW,ITERPF,ITERPK,IHDDFL,IFLD,IFO,ISA,JDRY,IDRY,I
      REAL SGN,B2,BM1,BDEL,BDEL0,SSEMAX,TOLDSQ,DSQ,
     &     DMX,DMAX,FAC,ADMX,FCONV,FLCNV
      DOUBLE PRECISION AP
      DIMENSION B2(NIB,NPLIST),NLIP(NPI),
     &          IVAL(8),
     &          LN(NPLIST),ISENS(NPLIST),DSQ(NOINT),IDINT(NOINT)
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
C
      ISTOP=0
C
C     SET INITIAL SIGN OF LAMBDA; RESET IPRINT AND LPRINT
      IF (IINT.EQ.0) THEN
         IUNCRW = 0
         IF (ISGN.EQ.-1) THEN
            SGN = -1.
         ELSE
            SGN = 1.
         ENDIF
         IPRINT = 0
         LPRINT = 0
         CALL DATE_AND_TIME(DATE0,TIME0,ZONE,IVAL)
         IF (IOSTAR.NE.1) WRITE(*,95) DATE0, TIME0
         WRITE(IOUTG,70)
      ELSE IF (JMAN.NE.0) THEN
         IHDDFL = 0
         IFLD = 0
         IFO = 0
         ISA = 0
         IDRY = 0
         JDRY = 0
         ITERPF = 0
         ITERPK = 0
         RETURN
      ELSE
         IUNCRW = 1
         DMX = DMAX
         AP = 1.
         FAC = 1.
         ADMX = 10.*FCONV
         ITERPF = 0
         ITERPK = 0
         IHDDFL = 0
         IFLD = 0
         IFO = 0
         ISA = 0
         IDRY = 0
         JDRY = 0
      ENDIF
C
C     SET VALUES OF STARTING PARAMETERS
      IF (IIB.LT.NIB) THEN
         IIB=IIB+1
      ELSE
         IIB=1
      ENDIF
      DO 10 I=1,NPLIST
         B(I)=B2(IIB,I)
 10   CONTINUE
      IF (IIB.GT.1) GO TO 50
C
C     SET NUMBER OF NEXT CONFIDENCE INTERVAL; CHANGE SIGN OF LAMBDA;
C     OR RETURN STOP INDICATOR
      IF (IDIF.EQ.1.AND.IINT.GT.0.AND.IINT.LE.(NHI+NQI)) IINT=IINT+1
      IF (IINT.LT.NOINT) THEN
         IINT=IINT+1
      ELSE IF (ISGN.EQ.0.AND.SGN.GT.0) THEN
         IINT=1
         SGN=-1.
      ELSE
         ISTOP=1
         CALL DATE_AND_TIME(DATE,TIME,ZONE,IVAL)
         IF (IOSTAR.NE.1) WRITE(*,95) DATE0, TIME0
         IF (IOSTAR.NE.1) WRITE(*,96) DATE, TIME
         WRITE(IOUTG,95) DATE0, TIME0
         WRITE(IOUTG,96) DATE, TIME
         GO TO 100
      ENDIF
      SSEMAX=TOLDSQ*DSQ(IINT)
C
C     SET CONVERSION FACTOR FOR INTERVAL VARIABLE
      FLCNV=1.0
      ID=IINT-NHI-NQI
      IF (ID.GT.0.AND.LN(NLIP(ID)).GT.0) 
     &   FLCNV=1./LOG(10.)
C
C     FOR MANUAL PARAMETER ADJUSTMENT
 50   IF (IMAN.NE.0) THEN
         JMAN=1
         ITERM=0
         ITRM1=0
         IBEY=0
         BM1=B(IMAN)
         IF (LN(IMAN).GT.0) BM1=ALOG(BM1)
         ISENS(IMAN)=-ISENS(IMAN)
         NPE=NPE-1
         BDEL=BDEL0
      ENDIF
C     
      I=IINT
      IF (IDIF.EQ.1.AND.I.GT.1) THEN
         IF (IINT.LE.(NHI+NQI)) THEN
            I=(I+1)/2
         ELSE
            I=I-(NHI+NQI)/2
         ENDIF
      ENDIF
      I=INT(I*SGN)
      WRITE(IOUTG,80) I,IIB
      IF (IOUT.NE.IOUTG) WRITE(IOUT,80) I,IIB
      IF (IINT.LE.(NHI+NQI)) THEN
        IF (IDIF.EQ.1) THEN
          WRITE(IOUTG,86) OBSNAM(IDINT(IINT)),OBSNAM(IDINT(IINT+1))
          IF (IOUT.NE.IOUTG) WRITE(IOUT,86) OBSNAM(IDINT(IINT)),
     &                                      OBSNAM(IDINT(IINT+1))
        ELSE
          WRITE(IOUTG,85) OBSNAM(IDINT(IINT))
          IF (IOUT.NE.IOUTG) WRITE(IOUT,85) OBSNAM(IDINT(IINT))
        END IF
      ELSE
        WRITE(IOUTG,87) PARNAM(IINT-NHI-NQI)
        IF (IOUT.NE.IOUTG) WRITE(IOUT,87) PARNAM(IINT-NHI-NQI)
      END IF
      WRITE(*,90) I,IIB
C
 70   FORMAT(//,1X,80('*'))
 80   FORMAT(//,' CALCULATION OF CONFIDENCE INTERVAL NO.',I5,/,
     :'   STARTING PARAMETER SET NO.',I3)
 85   FORMAT(' OBSNAM: ',A)
 86   FORMAT(' OBSNAM1: ',A,'   OBSNAM2: ',A)
 87   FORMAT(' PARNAM: ',A)
 90   FORMAT(' CONFIDENCE INTERVAL NO.',I5,'  PARAMETER SET NO.',I3)
 95   FORMAT(' PROCESS STARTED: ',2A)
 96   FORMAT(' PROCESS STOPPED: ',2A)
C
 100  RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1SN(IINT,NPE,ND,NH,NHI,NQT,NQI,NPI,ITYP,NLIP,
     &                      WLIP,LN,H,X,WT,WTQ,Z,WCI,OBSNAM,IDIF,IOUT,
     &                      ISTOP,ITPR,IDINT,NOINT,IFO,FL,FL0,
     &                      ITERP,TOLY,NPLIST,NLJP)
C-----VERSION 1001 05APR2002 (SC)
C     ******************************************************************
C     COPY SENSITIVITIES TO Z AND WEIGHT TO WCI; CHECK THAT SENSITIVITY
C     WAS CALCULATED; WRITE FL FROM FORMER ITERATION.
C     ******************************************************************
      CHARACTER*12 OBSNAM(NH+NQT)
      DOUBLE PRECISION Z(NPLIST),DFMX,FLDIF
      INTEGER IDINT,ITPR,ISTOP,IOUT,IDIF,ITYP,NQI,NHI,IINT,NH,NQT,NPE,
     &        NPI,NLIP,LN,ND,NOINT,ID,IDD,I,NLJP,ITERP,IFO,NPLIST
      REAL WCI,WLIP,H,X,WT,WTQ,FL,FL0,TOLY
      DIMENSION NLIP(NPI),WLIP(NPI),LN(NPLIST),H(ND),X(NPE,ND),
     &          WT(NH),WTQ(NQT,NQT),IDINT(NOINT),NLJP(NPI)
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
C
C     HEAD INTERVAL
      IF (IINT.LE.NHI) THEN
         ID=IDINT(IINT)
         WCI=1./WT(ID)
         IF (IDIF.EQ.1.AND.WCI.GT.0.) THEN
            IDD=IDINT(IINT+1)
            IF (WT(IDD).GT.0.) THEN
               WCI=WCI+1./WT(IDD)
            ELSE
               WCI=WT(IDD)
            ENDIF
         ENDIF
C
C     FLOW INTERVAL
      ELSE IF (IINT.LE.NHI+NQI) THEN
         ID=IDINT(IINT)-NH
         WCI=1./WTQ(ID,ID)
         ID=ID+NH
         IF (IDIF.EQ.1.AND.WCI.GT.0.) THEN
            IDD=IDINT(IINT+1)-NH
            IF (WTQ(IDD,IDD).GT.0.) THEN
               WCI=WCI+1./WTQ(IDD,IDD)
            ELSE
               WCI=WTQ(IDD,IDD)
            ENDIF
            IDD=IDD+NH
         ENDIF
C        
C     PARAMETER INTERVAL
      ELSE 
         ID=IINT-NHI-NQI
         WCI=WLIP(ID)
         DO 10 I=1,NPE
            Z(I)=0.
 10      CONTINUE
         Z(NLJP(ID))=1.
         IDD=NLIP(ID)
         IF (LN(IDD).GT.0) THEN
            FL=LOG(B(IDD))
         ELSE
            FL=B(IDD)
         ENDIF
         IF (ITPR.EQ.1) THEN
            IF (ITYP.EQ.2) THEN
               WRITE(IOUT,81) PARNAM(IDD),FL
            ELSE
               WRITE(IOUT,80) PARNAM(IDD),FL
            ENDIF
         ENDIF
         GO TO 100
      ENDIF
C
      ID=IDINT(IINT)
      FL=H(ID)
      IF (IDIF.EQ.1) THEN
         IDD=IDINT(IINT+1)
         FL=H(IDD)-FL
      END IF
      IF (ITPR.EQ.1) THEN
         IF (ITYP.EQ.2) THEN
            IF (IDIF.EQ.1) THEN
               WRITE(IOUT,88) OBSNAM(ID),OBSNAM(IDD),FL
            ELSE
               WRITE(IOUT,86) OBSNAM(ID), FL
            ENDIF
         ELSE
            IF (IDIF.EQ.1) THEN
               WRITE(IOUT,87) OBSNAM(ID),OBSNAM(IDD),FL
            ELSE
               WRITE(IOUT,85) OBSNAM(ID), FL
            ENDIF
         ENDIF
      ENDIF
      IF (ISTOP.NE.0) GO TO 100
      IF (WCI.LE.0) THEN
         ISTOP=2
      ELSE
         DO 20 I=1,NPE
            Z(I)=X(I,ID)
            IF (IDIF.EQ.1) Z(I)=X(I,IDD)-Z(I)
 20      CONTINUE
         IF (ITPR.EQ.1) THEN
            WRITE(IOUT,90)
            WRITE(IOUT,95) (Z(I),I=1,NPE)
         ENDIF
         ISTOP=5
         DO 30 I=1,NPE
            IF(Z(I).NE.0.) ISTOP=0
 30      CONTINUE
      ENDIF
C
 100  IF (ITYP.NE.2) WCI=0.
C
 80   FORMAT(/,'PARNAM:',A12,3X,' FL=',G11.5)
 81   FORMAT(/,'PARNAM:',A12,3X,' FL-ER=',G11.5)
 85   FORMAT(/,'OBSNAM:',A12,3X,' FL=',G11.5)
 86   FORMAT(/,'OBSNAM:',A12,3X,' FL-ER=',G11.5)
 87   FORMAT(/,'OBSNAM1:',A12,3X,'OBSNAM2:',A12,3X,' FL=',G11.5)
 88   FORMAT(/,'OBSNAM1:',A12,3X,'OBSNAM2:',A12,3X,' FL-ER=',G11.5)
 90   FORMAT(/,' SENSITIVITIES:')
 95   FORMAT(6(2X,G11.5))
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1IT(
     &     X,ND,NPE,HOBS,WT,WP,C,SCLE,G,H,D,DMAX,CSA,ISTOP,
     &     IFO,AMP,AP,DMX,IOUT,ITERP,ADMX,LN,MPR,PRM,
     &     ER,RSQP,SSE,U,Z,WCI,CSV,DSQ,SGN,NIPR,IPR,WTP,
     &     NH,NHI,WTQ,IOWTQ,ITYP,ITPR,IMAN,ITERM,BPRI,NPLIST,IPRAR,
     &     MPRAR,NDMHAR,NQTDR,NDRNI,NQTRV,NRIVI,NQTGB,NGHBI,NQTST,
     &     NSTRI,NQTCH,NCHDI,NQTDT,NDRTI,WTPS,WTQS,RSQO,RSQOO,
     &     IOSTAR,FL,FLCNV,BS,TOLP,TOLS,OBSNAM,EQNAM,IINT,IIB,IWRP,IDIF,
     &     NQI,IBEFLG,VAR,IDRY,IACT,TOLY,FL0)
C-----VERSION 1001 19JUN2003 (SC)
C     ******************************************************************
C     REGRESSION BY THE MODIFIED GAUSS-NEWTON METHOD TO ESTIMATE 
C     PARAMETERS FOR CONFIDENCE INTERVALS BY THE VECCHIA & COOLEY (1987)
C     METHOD.
C
C     TO CALCULATE LAMBDA (ALAM): SENSITIVITIES FOR THE CONFIDENCE 
C     INTERVAL POINT IS STORED IN Z; VARIANCE OF MEASUREMENT ERROR
C     IS IN WCI; CRITICAL VALUE IS IN DSQ; LAMBDA SIGN IS IN SGN
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DOUBLE PRECISION C(NPE,NPE),SCLE(NPE),D(NPE),DTMPA,U(NPE),VAR,
     : Z(NPE),G(NPE),DTMPB,UZ,DG,DD,GG,CSV(NPE,NPE),ALAM,AP,UGUZ,UG
      REAL X,HOBS,H,WT,WP,WTP,PRM,BPRI,WTQ,DMAX,CSA,AMP,TOLY,FL0,
     &     DMX,ADMX,ER,RSQP,SSE,WCI,DSQ,SGN,TMPA,W,DET,SPR,DDC,DMXO,
     &     WTPS,WTQS,RSQO,RSQOO,FL,FLCNV,BS,TOLP,TOLS,WTR,XK,XL,BDIF
      INTEGER ND,NPE,LN,NIPR,ISTOP,IFO,IOUT,ITERP,MPR,JJ,IBEFLG,
     &        IPR,NH,NHI,IOWTQ,ITYP,ITPR,IMAN,ITERM,NPLIST,JP,
     &        IPRAR,MPRAR,NDMHAR,NP1,IP,IIPP,I,J,N,N1,N2,N3,M,IMP,IP1,
     &        NQTDR,NDRNI,NQTRV,NRIVI,NQTGB,NGHBI,NQTST,NSTRI,NQTCH,
     :        NCHDI,NQTDT,NDRTI,IINT,IIB,IOSTAR,IWRP,IDIF,NQI,K,K1,L,L1
      DIMENSION X(NPE,ND),HOBS(ND),WT(ND),WP(MPRAR),H(ND),
     1          LN(NPLIST),PRM(NPLIST+1,MPRAR),
     2          NIPR(IPRAR),BPRI(IPRAR),BS(NPLIST)
      DIMENSION WTQ(NDMHAR,NDMHAR),WTQS(NDMHAR,NDMHAR),WTP(IPRAR,IPRAR),
     &          WTPS(IPRAR,IPRAR)
      CHARACTER*12 OBSNAM(ND)
      CHARACTER*10 EQNAM(MPRAR)
      CHARACTER*70 FNAME
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
C
  510 FORMAT (/,' ITERATION NO. = ',I5)
  511 FORMAT (/,' ITERATION NO. = ',I5,'  IN MANUAL ITERATION NO.',I3)
  515 FORMAT (2X,' SSE  = ',G11.5,' DET  = ',G11.5,' AMP  = ',G11.5,
     :' AP   = ',G11.5,/,2X,' DMX  = ',G11.5,' PAR  = ',A10,1X,
     :' ALAM = ',G11.5,' ER   = ',G11.5,/,2X,' FL+ER= ',G11.5,//,
     :' UPDATED ESTIMATES OF REGRESSION PARAMETERS :',/,
     :13(3X,A10,3X,A10,3X,A10,3X,A10,3X,A10,3X,A10,/))
  520 FORMAT (6(2X,G11.4))
  530 FORMAT (//,' WEIGHTED RESIDUALS AT LIMIT FOR INTERVAL ',I5,
     & '; STARTING VALUES',I3,/,
     &1X,'OBSNO',1X,'   OBS. NAME',2X,'WEIGHT. RES.')
  540 FORMAT (1X,I5,1X,A12,2X,G10.3)
  550 FORMAT (1X,I5,1X,A12,2X,'     OMITTED')
  600 FORMAT(/,' PARAMETER ESTIMATION CONVERGED BY SATISFYING TOL',A1,
     1' CRITERIA',/)
C
C-------INITIALIZE SOME VARIABLES.
      NP1 = NPE-1
      AMP = 0.
      RSQP = 0.
C
C-------ASSEMBLE LEAST-SQUARES MATRIX (C) AND GRADIENT VECTOR (G)
C----------INITIALIZE C AND CONVERT LN PARAMETERS
      DO 20 IP=1,NPE
         IIPP = IPPTR(IP)
         DO 10 I=1,NPE
            C(I,IP)=0.D00
   10    CONTINUE
         IF(LN(IIPP).GT.0) B(IIPP)=LOG(B(IIPP))
         G(IP)=0.
   20 CONTINUE
      IF (IACT.GT.0) THEN
         DO 25 IP=1,NPE
            Z(IP)=0. 
   25    CONTINUE
      END IF   
C
C----------CALCULATE SENSITIVITY CONTRIBUTIONS TO C AND G.
C----------CALCULATE SUM OF SQUARED RESIDUALS.
C
C---- HEADS
      N1=NH-NHI
      IF (N1 .GT. 0) THEN
         DO 50 N=1,N1
            TMPA=HOBS(N)-H(N)
            W=WT(N)
            IF(W.LT.0.) W=1.E-20
            RSQP = RSQP+W*TMPA**2
            DO 40 IP=1,NPE
               DTMPA=DBLE(W)*DBLE(X(IP,N))
               DO 30 I=IP,NPE
                  C(I,IP)=DBLE(X(I,N))*DTMPA+C(I,IP)
   30          CONTINUE
               G(IP)=DTMPA*TMPA+G(IP)
   40       CONTINUE
   50    CONTINUE
      ENDIF
C
C-----FLOWS
      N1=1
      N3=0
C     DRAINS (DRN)
      M = NQTDR-NDRNI
      N1 = N1+N3
      N2 = N1+M-1
      N3 = NQTDR
      IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                             IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,0)
C     RIVERS (RIV)
      M = NQTRV-NRIVI
      N1 = N1+N3
      N2 = N1+M-1
      N3 = NQTRV
      IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                             IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,0)
C     GENERAL HEAD BOUNDARIES (GHB)
      M = NQTGB-NGHBI
      N1 = N1+N3
      N2 = N1+M-1
      N3 = NQTGB
      IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                             IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,0)
C     STREAMS (STR)
      M = NQTST-NSTRI
      N1 = N1+N3
      N2 = N1+M-1
      N3 = NQTST
      IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                             IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,0)
C     CONSTANT HEAD BOUNDARIES (CHD)
      M = NQTCH-NCHDI
      N1 = N1+N3
      N2 = N1+M-1
      N3 = NQTCH
      IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                             IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,0)
C     DRAIN RETURN FLOWS (DRT)
      M = NQTDT-NDRTI
      N1 = N1+N3
      N2 = N1+M-1
      N3 = NQTDT
      IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                             IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,0)
C
C-----PRIOR INFORMATION ON PARAMETER SUMS
      IF(MPR.GT.0) THEN
         DO 76 IMP=1,MPR
            TMPA=0.
            DO 70 IP=1,NPLIST
               TMPA=TMPA+PRM(IP,IMP)*B(IP)
   70       CONTINUE
            TMPA=PRM(NPLIST+1,IMP)-TMPA
            DO 74 IP=1,NPE
               IIPP=IPPTR(IP)
               IF(PRM(IIPP,IMP).NE.0.) THEN
                  DTMPA=DBLE(WP(IMP))*DBLE(PRM(IIPP,IMP))
                  DO 72 I=IP,NPE
                     C(I,IP)=DBLE(PRM(IPPTR(I),IMP))*DTMPA+C(I,IP)
   72             CONTINUE
                  G(IP)=DTMPA*TMPA+G(IP)
               ENDIF
   74       CONTINUE
            TMPA=SQRT(WP(IMP))*TMPA
            RSQP=RSQP + TMPA**2
   76    CONTINUE
      ENDIF
C
C-----CORRELATED PRIOR
      IF (IPR.GT.0) THEN
         DO 86 I = 1, NPE
           DO 84 J = I, NPE
             DO 82 K = 1, IPR
               K1 = NIPR(K)
               IF (K1.EQ.I) THEN
                  DO 80 L = 1, IPR
                     W = WTP(L,K)
                     L1 = NIPR(L)
                     IF (L1.EQ.J) THEN
                        C(J,I) = C(J,I) + W
                     ENDIF
                     IF (J.EQ.I) THEN
                        BDIF = BPRI(L) - B(L1)
                        G(I) = G(I) + W*BDIF
                     ENDIF
   80             CONTINUE
               ENDIF
   82        CONTINUE
   84      CONTINUE
   86    CONTINUE
         DO 95 I = 1, IPR
            BDIF = 0.0
            DO 90 L = 1, IPR
              L1 = NIPR(L)
              BDIF = BDIF + WTPS(I,L)*(BPRI(L) -B(L1))
   90       CONTINUE
            RSQP = RSQP + BDIF**2
   95    CONTINUE
      ENDIF
C
C-------SCALE COEFFICIENT MATRIX AND GRADIENT VECTOR
      DO 110 IP=1,NPE
         SCLE(IP)=1.D00
         IF(C(IP,IP).GT.1.D-30) SCLE(IP)=DSQRT(C(IP,IP))
  110 CONTINUE
      IF(NPE.GT.1) THEN
         DO 130 IP=1,NP1
            DTMPA=SCLE(IP)
            IP1=IP+1
            DO 120 I=IP1,NPE
               C(I,IP)=C(I,IP)/(SCLE(I)*DTMPA)
               C(IP,I)=C(I,IP)
               CSV(IP,I)=C(I,IP)
               CSV(I,IP)=C(I,IP)
  120       CONTINUE
            G(IP)=G(IP)/DTMPA
            Z(IP)=Z(IP)/DTMPA
            C(IP,IP)=1.D00
  130    CONTINUE
      ENDIF
      G(NPE)=G(NPE)/SCLE(NPE)
      Z(NPE)=Z(NPE)/SCLE(NPE)
      C(NPE,NPE)=1.D00
C
C-------COMPUTE SCALED DISPLACEMENT COMPONENTS
      IF (IACT.LT.2) CALL SUNC1NLI1SL(C,D,G,NPE,1,ISTOP,DET)
C     COMPUTE VAR AND COVARIANCE MATRIX FOR BEALE2 AND CORFAC
      IF (IACT.GT.0) THEN
         N = ND-NHI-NQI-IDRY+MPR+IPR-NPE
         IF (N.LT.1) N = 1
         TMPA = REAL(N)
         VAR = RSQP/TMPA
         IF (IACT.LT.2) THEN
            IF (NPE.GT.1) THEN
               CALL SUNC1NLI1IN(NPE,C)
            ELSE
               C(1,1) = 1.0/C(1,1)
            ENDIF
            DO 135 IP = 1, NPE
               DTMPA = SCLE(IP)
               DO 134 I = IP, NPE
                  C(I,IP) = VAR*C(I,IP)/(SCLE(I)*DTMPA)
                  C(IP,I) = C(I,IP)
  134          CONTINUE
  135       CONTINUE
         END IF
         RETURN 
      END IF   
C      
      ALAM=0.
      IF (ISTOP.GT.0) THEN
         GO TO 165
      ELSE
         CALL SUNC1NLI1SL(C,U,Z,NPE,0,ISTOP,DET)
C        COMPUTE QUADRATIC FORMS IN ALAM INVOLVING G AND Z VECTORS
         DG = 0.
         UZ = 0.
         DO 140 J=1,NPE
            DG = DG + D(J)*G(J)
            UZ = UZ + U(J)*Z(J)
  140    CONTINUE
C        COMPUTE LAMBDA
         DTMPA = DSQ - RSQP + DG
         IF (DTMPA.GT.0.) ALAM=SGN*DSQRT(DTMPA/(UZ+WCI))
C        COMPUTE PARAMETER DISPLACEMENTS
         DO 150 J=1,NPE
            D(J) = D(J) + ALAM*U(J)
  150    CONTINUE
      ENDIF
C
C     IF WEIGHTED RESIDUALS ARE TO BE PRINTED, SAVE X, C, SCLE, U, 
C     AND UZ FROM FIRST ITERATION
      IF (IWRP.GT.0.AND.ITERP.EQ.1) THEN
         OPEN(UNIT=IWRP+1,FORM='UNFORMATTED',STATUS='SCRATCH',IOSTAT=J)
         IF (J.NE.0) THEN
            INQUIRE(UNIT=IWRP+1,NAME=FNAME)
            WRITE(*,*) ' CANNOT OPEN SCRATCH FILE FOR CALCULATION OF',
     &                 ' WEIGHTED RESIDUALS, I.E. UNIT NUMBER ',IWRP+1
            WRITE(*,*) ' NAMED ',FNAME
            WRITE(IOUT,*) ' CANNOT OPEN SCRATCH FILE FOR CALCULATION OF'
     &                ,' WEIGHTED RESIDUALS, I.E. UNIT NUMBER ',IWRP+1
            WRITE(IOUT,*) ' NAMED ',FNAME
            STOP
         ENDIF
         WRITE(IWRP+1) X,C,SCLE,U,UZ
         REWIND(IWRP+1)
      END IF   
C
C---------MARQUARDT LOOP
  155 DG=0.
      DD=0.
      GG=0.
      DO 160 J=1,NPE
         DTMPA=ALAM*Z(J)+G(J)
         DG=DG+D(J)*DTMPA
         DD=DD+D(J)*D(J)
         GG=GG+DTMPA*DTMPA
  160 CONTINUE
      IF (DG.GT.CSA*DSQRT(DD*GG)) GO TO 210
  165 AMP=1.5*AMP+.001
      IF (AMP.GT.1.) GO TO 210
C     RECREATE C MATRIX
      IF (NPE.GT.1) THEN
         DO 180 IP=1,NP1
            IP1=IP+1
            DO 170 I=IP1,NPE
               C(I,IP) = CSV(I,IP)
               C(IP,I) = CSV(IP,I)
  170       CONTINUE
            C(IP,IP)=1.D00+AMP
  180    CONTINUE
      ENDIF
      C(NPE,NPE)=1.D00+AMP
C     COMPUTE PARAMETER STEP LENGTHS
      CALL SUNC1NLI1SL(C,D,G,NPE,1,ISTOP,DET)
      ALAM=0.
      IF (ISTOP.GT.0) THEN
         GO TO 165
      ELSE
         CALL SUNC1NLI1SL(C,U,Z,NPE,0,ISTOP,DET)
C        COMPUTE QUADRATIC FORMS IN ALAM INVOLVING G AND Z VECTORS
         DG = 0.
         UZ = 0.
         DO 190 J=1,NPE
            DG = DG + D(J)*G(J)
            UZ = UZ + U(J)*Z(J)
  190    CONTINUE
C        COMPUTE LAMBDA
         DTMPA = DSQ - RSQP + DG
         IF (DTMPA.GT.0.) ALAM=SGN*DSQRT(DTMPA/(UZ+WCI))
C        COMPUTE PARAMETER DISPLACEMENTS
         DO 200 J=1,NPE
            D(J) = D(J) + ALAM*U(J)
  200    CONTINUE
      ENDIF
      GO TO 155
C
C-------IF MATRIX EQUATION IS SINGULAR,
C---------CONVERT NATURAL LOGS OF PARAMETER VALUES AND RETURN
  210 IF (ISTOP.GT.0) THEN
         DO 220 I=1,NPE
            IP=IPPTR(I)
            IF (LN(IP).GT.0) THEN
               B(IP)=EXP(B(IP))
               IF (B(IP).LT.1.E-14) B(IP)=1.E-14
            ENDIF
  220    CONTINUE
         RETURN
      ENDIF
C
C-------UNSCALE PARAMETER CHANGE VECTOR
      DO 230 IP=1,NPE
         D(IP)=D(IP)/SCLE(IP)
  230 CONTINUE
      ER=ALAM*WCI
C
C-------COMPUTE DAMPING PARAMETER AND NEW ESTIMATES OF REGRESSION
C-------PARAMETERS
      ADMX=0.
      DMXO=DMX
      DO 290 J=1,NPE
         JP=IPPTR(J)
         DTMPA=D(J)/BS(JP)
         DTMPB=DABS(DTMPA)
         IF (DTMPB.LT.ADMX) GO TO 290
         JJ=JP
         DMX=DTMPA
         ADMX=DTMPB
  290 CONTINUE
C     COMPUTE AP USING OSCILLATION CONTROL
      IF(ITERP.GT.1) THEN
         SPR=DMX/(AP*DMXO)
         IF(SPR.LT.-1.) THEN
            AP=.5/ABS(SPR)
         ELSE
            AP=(3.+SPR)/(3.+ABS(SPR))
         ENDIF
      ENDIF
      IF(AP*ADMX.GT.DMAX) AP=DMAX/ADMX
C
C     UPDATE PARAMETERS
      DO 300 I=1,NPE
         IP=IPPTR(I)
         DDC=AP*D(I)
         B(IP)=B(IP)+DDC
         D(I)=DDC
  300 CONTINUE
C
C-----RETRANSFORM PARAMETERS
      DO 310 I=1,NPE
         IP = IPPTR(I)
         IF (LN(IP).GT.0) THEN
            B(IP)=EXP(B(IP))
            IF (B(IP).LT.1.E-14) B(IP)=1.E-14
         ENDIF
  310 CONTINUE
C
C-------PRINT DATA FROM CURRENT ITERATION
      SSE=RSQP
      FL=FL+ER
      IF (ITYP.EQ.2) SSE=SSE+ER*ER/WCI
      IF (ITPR.EQ.1) THEN
         IF (IMAN.EQ.0) THEN
            WRITE(IOUT,510) ITERP
            IF (IOSTAR.NE.1) WRITE(*,510) ITERP
         ELSE
            WRITE(IOUT,511) ITERP,ITERM+1
            IF (IOSTAR.NE.1) WRITE(*,511) ITERP,ITERM+1
         ENDIF
         WRITE(IOUT,515) SSE,DET,AMP,AP,DMX,PARNAM(JJ),ALAM,ER*FLCNV,
     &                   FL*FLCNV,(PARNAM(IPPTR(IP)),IP=1,NPE)
         WRITE(IOUT,520) (B(IPPTR(IP)),IP=1,NPE)
         IF (IOSTAR.NE.1) THEN
            WRITE(*,515) SSE,DET,AMP,AP,DMX,PARNAM(JJ),ALAM,ER*FLCNV,
     &                      FL*FLCNV,(PARNAM(IPPTR(IP)),IP=1,NPE)
            WRITE(*,520) (B(IPPTR(IP)),IP=1,NPE)
         ENDIF
      ENDIF
C
C-------CHECK FOR CONVERGENCE
      IF (TOLY.GT.1.E-12) THEN
         IF (ITERP.GT.1) THEN
            DTMPA=MAX(ABS(FL+FL0),1.D-12)
            DTMPA=2.*(FL-FL0)/DTMPA
            IF (DABS(DTMPA).LT.TOLY) THEN
               IFO=3
               WRITE(IOUT,600) 'Y'
               IF (IOSTAR.NE.1) WRITE(*,600) 'Y'
            END IF
         END IF    
         FL0=FL
      END IF     
      IF (TOLS.GT.0.) THEN
         IF (ITERP.GT.2) THEN
            TMPA = (ABS(RSQP-RSQO)/RSQP) + (ABS(RSQO-RSQOO)/RSQO)
            IF (TMPA.LT.TOLS) THEN
               IFO = 2
               WRITE(IOUT,600) 'S'
               IF (IOSTAR.NE.1) WRITE(*,600) 'S'
            ENDIF
         ENDIF
         IF (ITERP.GT.1) RSQOO = RSQO
         IF (ITERP.GT.0) RSQO = RSQP
      ENDIF
      IF(ADMX.LE.TOLP) THEN
         IFO=1
         WRITE(IOUT,600) 'P'
         IF (IOSTAR.NE.1) WRITE(*,600) 'P'
      ENDIF
C      
C-------PRINT WEIGHTED RESIDUALS IF SOLUTION CONVERGED AND IWRP > 0
      IF (IWRP.GT.0.AND.IFO.GT.0) THEN
         I=IINT
         IF (IDIF.EQ.1.AND.I.GT.1) THEN
            IF (IINT.LE.(NHI+NQI)) THEN
               I=(I+1)/2
            ELSE
               I=I-(NHI+NQI)/2
            ENDIF
         ENDIF
         I=INT(I*SGN)
         WRITE(IWRP,530) I, IIB
C
C        READ X, C, SCLE, U, AND UZ FROM FIRST ITERATION
         READ(IWRP+1) X,C,SCLE,U,UZ
         CLOSE(IWRP+1)
C
C        RECALCULATE G
         DO 330 IP=1,NPE
            G(IP)=0.
  330    CONTINUE
C        HEADS
         N1=NH-NHI
         IF (N1 .GT. 0) THEN
            DO 350 N=1,N1
               TMPA=HOBS(N)-H(N)
               W=WT(N)
               IF(W.LT.0.) W=1.E-20
               DO 340 IP=1,NPE
                  DTMPA=DBLE(W)*DBLE(X(IP,N))
                  G(IP)=DTMPA*TMPA+G(IP)
  340          CONTINUE
  350       CONTINUE
         ENDIF
C        FLOWS
         N1=1
         N3=0
C        DRAINS (DRN)
         M = NQTDR-NDRNI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTDR
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                            H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,-1)
C        RIVERS (RIV)
         M = NQTRV-NRIVI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTRV
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                            H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,-1)
C        GENERAL HEAD BOUNDARIES (GHB)
         M = NQTGB-NGHBI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTGB
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                            H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,-1)
C        STREAMS (STR)
         M = NQTST-NSTRI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTST
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                            H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,-1)
C        CONSTANT HEAD BOUNDARIES (CHD)
         M = NQTCH-NCHDI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTCH
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                            H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,-1)
C        DRAIN RETURN FLOWS (DRT)
         M = NQTDT-NDRTI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTDT
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                            H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,-1)
C        PRIOR INFORMATION ON PARAMETER SUMS
         IF(MPR.GT.0) THEN
            DO 376 IMP=1,MPR
               TMPA=0.
               DO 370 IP=1,NPLIST
                  TMPA=TMPA+PRM(IP,IMP)*B(IP)
  370          CONTINUE
               TMPA=PRM(NPLIST+1,IMP)-TMPA
               DO 374 IP=1,NPE
                  IIPP=IPPTR(IP)
                  IF(PRM(IIPP,IMP).NE.0.) THEN
                     DTMPA=DBLE(WP(IMP))*DBLE(PRM(IIPP,IMP))
                     G(IP)=DTMPA*TMPA+G(IP)
                  ENDIF
  374          CONTINUE
  376       CONTINUE
         ENDIF
C        CORRELATED PRIOR
         IF (IPR.GT.0) THEN
            DO 386 I = 1, NPE
              DO 384 J = I, NPE
                DO 382 K = 1, IPR
                  K1 = NIPR(K)
                  IF (K1.EQ.I) THEN
                     DO 380 L = 1, IPR
                        W = WTP(L,K)
                        L1 = NIPR(L)
                        IF (J.EQ.I) THEN
                           BDIF = BPRI(L) - B(L1)
                           G(I) = G(I) + W*BDIF
                        ENDIF
  380                CONTINUE
                  ENDIF
  382           CONTINUE
  384         CONTINUE
  386       CONTINUE
         ENDIF
C
C        SCALE G, THEN CALCULATE UG=Q'W^(Y-F) AND UGUZ=Q'W^(Y-F)/Q'Q
         UG=0.
         DO 400 J=1,NPE
            DTMPA=SCLE(J)
            G(J)=G(J)/DTMPA
            UG=UG+U(J)*G(J)
            U(J)=U(J)/DTMPA
  400    CONTINUE
         UGUZ=UG/UZ
C
C        AT THIS STAGE VARIABLES HAVE THEN FOLLOWING DEFINITIONS:
C        UZ=Q'Q; UG=Q'W^(Y-F); UGUZ=Q'W^(Y-F)/Q'Q; U=(X'WX)^(-1)Z.
C        NOW CALCULATE AND PRINT WEIGHTED RESIDUALS.
C        HEADS
         N=NH-NHI
         DO 420 I=1,N
            W=WT(I)
            IF (W.LT.0.) THEN
                WRITE(IWRP,550) I,OBSNAM(I)
            ELSE
               W=SQRT(W)
               DTMPA=0.
               DO 410 J=1,NPE
                  DTMPA=DTMPA+X(J,I)*U(J)
  410          CONTINUE
               WTR=W*(HOBS(I)-H(I)-DTMPA*UGUZ)
               WRITE(IWRP,540) I,OBSNAM(I),WTR
            END IF    
  420    CONTINUE
C        FLOWS
         N1=1
         N3=0
C        DRAINS (DRN)
         M = NQTDR-NDRNI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTDR
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                           H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C        RIVERS (RIV)
         M = NQTRV-NRIVI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTRV
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                           H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C        GENERAL HEAD BOUNDARIES (GHB)
         M = NQTGB-NGHBI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTGB
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                           H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C        STREAMS (STR)
         M = NQTST-NSTRI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTST
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                           H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C        CONSTANT HEAD BOUNDARIES (CHD)
         M = NQTCH-NCHDI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTCH
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                           H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C        DRAIN RETURN FLOWS (DRT)
         M = NQTDT-NDRTI
         N1 = N1+N3
         N2 = N1+M-1
         N3 = NQTDT
         IF (M.GT.0) CALL SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,
     &                           H,IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C        PRIOR INFORMATION ON PARAMETER SUMS
         IF(MPR.GT.0) THEN
            DO 450 IMP=1,MPR
               TMPA=0.
               DO 430 IP=1,NPLIST
                  TMPA=TMPA+PRM(IP,IMP)*B(IP)
  430          CONTINUE
               TMPA=PRM(NPLIST+1,IMP)-TMPA
               DTMPA=0.0
               DO 440 IP=1,NPE
                  IIPP=IPPTR(IP)
                  DTMPA=DTMPA+DBLE(PRM(IIPP,IMP))*U(IP)
  440          CONTINUE
               WTR=SQRT(WP(IMP))*(TMPA-DTMPA*UGUZ)
               WRITE(IWRP,540) ND+IMP,EQNAM(IMP),WTR
  450       CONTINUE
         ENDIF
C        CORRELATED PRIOR
         IF (IPR.GT.0) THEN
            DO 470 I=1,IPR
               WTR=0.0
               DTMPA=0.0
               DO 460 J=1,IPR
                  W=WTPS(I,J)
                  IP=NIPR(J)
                  TMPA=B(IP)
                  IF (LN(IP).GT.0) TMPA=LOG(TMPA)
                  WTR=WTR+W*U(IP)
                  DTMPA=DTMPA+W*(BPRI(J)-TMPA)
  460          CONTINUE
               WTR=DTMPA-WTR*UGUZ
               WRITE(IWRP,540) ND+MPR+I,PARNAM(NIPR(I)),WTR
  470       CONTINUE      
         ENDIF
      END IF
C
C-------RESET NEGATIVE WEIGHTS THAT INDICATE DISCONNECTED OBSERVATIONS
      IF (NH.GT.0) THEN
         DO 480 I=1,NH
            IF (WT(I).LT.0.0) WT(I) = -WT(I)
  480    CONTINUE      
      END IF    
      IF (ND.GT.NH) THEN
         DO 490 I=1,NDMHAR
            IF (WTQ(I,I).LT.0.0) WTQ(I,I) = -WTQ(I,I)
  490    CONTINUE    
      ENDIF
C
      RETURN
      END
C=======================================================================C
      SUBROUTINE SUNC1NLI1SL(C,D,G,NPE,IND,ISTOP,DET)
C-----VERSION 1001 25FEB2003 (SC)
C     ******************************************************************
C         SOLVE SYSTEM OF LINEAR EQUATIONS BY LU-DECOMPOSITION
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      DOUBLE PRECISION C(NPE,NPE),D(NPE),G(NPE),DPIV,DTMPA,DSUM
      REAL DET
      INTEGER ISTOP,IND,NPE,NM1,K,KP1,J,I,IP1
C     ------------------------------------------------------------------
C         COMPUTE TRIAL PARAMETER STEP LENGTHS USING LDU FACTORIZATION:
C           DECOMPOSE MATRIX
      NM1=NPE-1
      ISTOP=0
C
C-----------LDU FACTORIZATION
      IF (IND.GT.0) THEN
         DET=1.
         DO 30 K=1,NM1
            DPIV=C(K,K)
            DET=DET*DPIV
            IF (DPIV.LT.1.D-13) THEN
               ISTOP=1
               RETURN
            ENDIF
            DPIV=1.D00/DPIV
            KP1=K+1
            DO 20 J=KP1,NPE
               DTMPA=C(J,K)*DPIV
               DO 10 I=J,NPE
                  C(I,J)=C(I,J)-DTMPA*C(I,K)
   10          CONTINUE
   20       CONTINUE
            C(K,K)=DPIV
   30    CONTINUE
         DET=DET*C(NPE,NPE)
         IF(C(NPE,NPE).LT.1.D-13) THEN
            ISTOP=1
            RETURN
         ENDIF
      ENDIF
C
C-----------INITIALIZE D
      DO 40 K=1,NPE
         D(K)=G(K)
   40 CONTINUE
C
C-----------FORWARD SUBSTITUTE
      DO 60 K=1,NM1
         DTMPA=D(K)*C(K,K)
         KP1=K+1
         DO 50 J=KP1,NPE
            D(J)=D(J)-C(J,K)*DTMPA
   50    CONTINUE
   60 CONTINUE
C
C-----------BACKWARD SUBSTITUTE
      D(NPE)=D(NPE)/C(NPE,NPE)
      DO 90 I=NPE-1,1,-1
         IP1=I+1
         DSUM=0.
         DO 70 J=IP1,NPE
            DSUM=DSUM+C(J,I)*D(J)
   70    CONTINUE
         D(I)=(D(I)-DSUM)*C(I,I)
   90 CONTINUE
C
      RETURN
      END
C=======================================================================
      SUBROUTINE SUNC1NLI1IN(NPE,C)
C-----VERSION 1001 20SEP2003 (SC)
C-----COPY OF SPES1GAU1IN, VERSION 1000 01FEB1992
C     ******************************************************************
C         COMPLETE CALCULATION OF THE INVERSE OF SCALED
C         COEFFICIENT MATRIX C STARTING FROM DECOMPOSED MATRIX
C         FROM SPES1GAU1SL, FOR NPE>1
C     ******************************************************************
C         SPECIFICATIONS:
C     ------------------------------------------------------------------
      INTEGER I, IM1, J, K, KP1, NPE, NP1
      DOUBLE PRECISION C(NPE,NPE), DSUM
C     ------------------------------------------------------------------
      NP1 = NPE - 1
      C(NPE,NPE) = 1.0/C(NPE,NPE)
      DO 50 K = 1, NP1
        KP1 = K + 1
        DO 20 I = KP1, NPE
          DSUM = 0.0
          IM1 = I - 1
          DO 10 J = K, IM1
            DSUM = DSUM + C(I,J)*C(J,K)
   10     CONTINUE
          C(K,I) = -DSUM
          C(I,K) = -DSUM*C(I,I)
   20   CONTINUE
        DO 40 I = 1, K
          DSUM = C(K,I)
          DO 30 J = KP1, NPE
            DSUM = DSUM + C(J,K)*C(I,J)
   30     CONTINUE
          C(K,I) = DSUM
          C(I,K) = C(K,I)
   40   CONTINUE
   50 CONTINUE
      RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1OC(IINT,ITYP,ITERP,NPE,ND,NHI,NQI,NPI,NLIP,LN,
     :                      H,ER,SGN,SSE,IOUT,IOIN,ISTOP,IDRY,IFO,IMAN,
     :                      ITERM,FLIM,BLIM,IDIF,IDINT,NOINT,NPLIST,
     &                      IOUTG,IOSTAR,FLCNV)
C-----VERSION 1001 25FEB2003 (SC)
C     ******************************************************************
C     WRITE RESULTS FOR CALCULATED CONFIDENCE INTERVAL.
C     ******************************************************************
      INTEGER IDINT,NPLIST,IDIF,ITERM,IMAN,IFO,IDRY,ISTOP,IOIN,
     &IOUT,ND,NHI,NQI,NPI,NPE,ITERP,ITYP,IINT,NLIP,LN,NOINT,ID,I,IP,
     &IFM1,IFM2,IOUTG,IOSTAR
      REAL FLIM,SSE,SGN,ER,BLIM,H,FLCNV
      DIMENSION NLIP(NPI),BLIM(NPLIST),LN(NPLIST),H(ND),
     &          IDINT(NOINT)
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
C
C     CHECK FOR ERROR DURING ITERATION
      IF (ISTOP.EQ.0) THEN
         IF (IFO.EQ.0) ISTOP=3
         IF (IDRY.GT.0) ISTOP=4
      ENDIF
      IF (ISTOP.EQ.1) THEN
         WRITE(IOUTG,101)
         IF (IOUT.NE.IOUTG) WRITE(IOUT,101)
         IF (IOSTAR.NE.1) WRITE(*,101)
         IF (IOIN.NE.1) WRITE(IOIN,101)
      ELSE IF (ISTOP.EQ.2) THEN
         WRITE(IOUTG,102)
         IF (IOUT.NE.IOUTG) WRITE(IOUT,102)
         IF (IOSTAR.NE.1) WRITE(*,102)
         IF (IOIN.NE.1) WRITE(IOIN,102)
      ELSE IF (ISTOP.EQ.3) THEN
         WRITE(IOUTG,103)
         IF (IOUT.NE.IOUTG) WRITE(IOUT,103)
         IF (IOSTAR.NE.1) WRITE(*,103)
         IF (IOIN.NE.1) WRITE(IOIN,103)
      ELSE IF (ISTOP.EQ.4) THEN
         WRITE(IOUTG,104)
         IF (IOUT.NE.IOUTG) WRITE(IOUT,104)
         IF (IOSTAR.NE.1) WRITE(*,104)
         IF (IOIN.NE.1) WRITE(IOIN,104)
      ELSE IF (ISTOP.EQ.5) THEN
         WRITE(IOUTG,105)
         IF (IOUT.NE.IOUTG) WRITE(IOUT,105)
         IF (IOSTAR.NE.1) WRITE(*,105)
         IF (IOIN.NE.1) WRITE(IOIN,105)
      ENDIF
C
C     CALCULATE FLIM
      IF (IMAN.EQ.0) THEN
         IF (IINT.LE.NHI) THEN
            ID=IDINT(IINT)
            FLIM=H(ID)
            IF (IDIF.EQ.1) FLIM=H(ID+1)-FLIM
         ELSE IF (IINT.LE.NHI+NQI) THEN
            ID=IDINT(IINT)
            FLIM=H(ID)
            IF (IDIF.EQ.1) FLIM=H(ID+1)-FLIM
         ELSE 
            ID=NLIP(IINT-NHI-NQI)
            FLIM=B(ID)
            IF (LN(ID).GT.0) FLIM=LOG(FLIM)
         ENDIF
      ENDIF
C
      I=IINT
      IF (IDIF.EQ.1.AND.I.GT.1) THEN
         IF (IINT.LE.(NHI+NQI)) THEN
            I=(I+1)/2
         ELSE
            I=I-(NHI+NQI)/2
         ENDIF
      ENDIF
      I=INT(I*SGN)
      ASSIGN 110 TO IFM1
      ASSIGN 130 TO IFM2
      IF (ITYP.EQ.2) THEN
         FLIM=FLIM+ER
         ASSIGN 120 TO IFM1
         ASSIGN 140 TO IFM2
      ENDIF
      WRITE(IOUTG,IFM1) I,FLIM*FLCNV
      IF (IOUT.NE.IOUTG) WRITE(IOUT,IFM1) I,FLIM*FLCNV
      IF (IOSTAR.NE.1) WRITE(*,IFM1) I,FLIM*FLCNV
      IF (IOIN.NE.1) THEN
         IF (IMAN.EQ.0) THEN
            WRITE(IOIN,IFM2) I,FLIM*FLCNV,SSE,ITERP,
     &         (B(IPPTR(IP)),IP=1,NPE)
         ELSE
            WRITE(IOIN,IFM2) I,FLIM*FLCNV,SSE,ITERM,
     &         (BLIM(IPPTR(IP)),IP=1,NPE)
         ENDIF
      ENDIF
C
 101  FORMAT(' MATRIX WAS SINGULAR; ITERATION STOPPED FOR:')
 102  FORMAT(' SENSITIVITES COULD NOT BE CALCULATED; ITERATION STOPPED F
     :OR:')
 103  FORMAT(' ITERATION FAILED TO CONVERGE FOR:')
 104  FORMAT(' CELLS HAVE GONE DRY AT OBSERVATION WELLS; ITERATION STOPP
     :ED FOR:')
 105  FORMAT(' ALL SENSITIVIES ARE ZERO; ITERATION STOPPED FOR:')
 110  FORMAT(/,' C.I. LIMIT FOR INTERVAL',I5,': FL=',G13.5,//,80('*')//)
 120  FORMAT(/,' P.I. LIMIT FOR INTERVAL',I5,': YP=',G13.5,//,80('*')//)
 130  FORMAT(' C.I.',I5,': FL=',G13.5,';  SSE=',G11.5,'; ITER=',I3,';  '
     :,'PAR:',50(2X,G11.4))
 140  FORMAT(' P.I.',I5,': YP=',G13.5,';  SSE=',G11.5,'; ITER=',I3,';  '
     :,'PAR:',50(2X,G11.4))
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE UNC1NLI1MO(NPE,LN,BDEL,BDIR,SSE,SSEMAX,RSQM1,RSQM2,
     &                      RSQM3,RSQM4,BM1,BM2,BM3,BM4,IFO,
     &                      NOINT,IINT,ND,NHI,NQI,NPI,SGN,H,NLIP,
     &                      ITERM,ITRM1,ITERP,ITERPF,ITMXP,DMX,DMAX,AP,
     &                      FAC,ADMX,FCONV,ISTOP,JMAN,ISENS,
     &                      FLIM,BLIM,IDIF,ITYP,ER,IDINT,IMAN,
     &                      NPLIST,IUNCRW,FLIM0,IBEY,BEYOND,BS,
     &                      TOLP,TOLS,TOLY)
C-----VERSION 1001 25FEB2003 (SC)
C     ******************************************************************
C     MANUAL ADJUSTMENT/OPTIMIZATION OF THE NPE'TH PARAMETER
C     ******************************************************************
      INTEGER IDINT,NPLIST,IMAN,ITYP,IDIF,JMAN,ISTOP,ISN,ISN1,
     &        ITMXP,ITERPF,ITERP,ITRM1,ITERM,NQI,NHI,NPI,ND,IINT,IFO,
     &        LN,NLIP,ISENS,NOINT,NN,I,J,IP,NPE,IUNCRW,IBEY
      REAL ER,FLIM,FCONV,ADMX,FAC,DMAX,DMX,SGN,BM1,BM2,BM3,
     &     BM4,BLIM,BDIR,BDEL,RSQM1,RSQM2,RSQM3,RSQM4,SSE,SSEMAX,H,FL,
     &     RSQP,TEMP,D1,FLIM0,BEYOND,BS,TOLP,TOLS,TOLY
      DOUBLE PRECISION DTMPA,AP
      DIMENSION LN(NPLIST),H(ND),NLIP(NPI),ISENS(NPLIST),BLIM(NPLIST),
     &          IDINT(NOINT),BS(NPLIST)
      INCLUDE 'param.inc'
C     ------------------------------------------------------------------
C
      NN=NPE+1
      IF (IINT.LE.NHI+NQI) THEN
         FL=H(IDINT(IINT))
         IF (IDIF.EQ.1) FL=H(IDINT(IINT+1))-FL
      ELSE
         J=NLIP(IINT-NHI-NQI)
         IF (LN(J).GT.0) THEN
            FL=LOG(B(J))
         ELSE
            FL=B(J)
         ENDIF
      ENDIF
      IF (ITYP.EQ.2) FL=FL+ER
      RSQP=-FL*SGN
C
C     IF AUTO ITERATION DID NOT CONVERGE
      IF (ITERP.EQ.ITMXP.AND.IFO.EQ.0) THEN
         IF (ITERM.EQ.0) CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,
     &                                    NPLIST)
         GO TO 100
      ENDIF
C
C     CHECK IF MANUAL STEP SIZE SHOULD BE REDUCED
      IF (SSE.GT.SSEMAX) THEN
         IF (ITERM.EQ.0) THEN
            IFO=0
            CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,NPLIST)
            GO TO 100
         ENDIF
         IBEY=1
         BEYOND=BM4
         IF (ITERM.EQ.1) THEN
C            BDEL=0.5*BDEL
            BDEL=0.5*ABS(BEYOND-BM1)
            BM2=BM1+BDEL
            BM4=BM2
         ELSE IF (ITERM.EQ.2) THEN
C            BDEL=0.5*ABS(BM2-BM1)
            BDEL=0.5*ABS(BEYOND-BM2)
            BM3=BM2+BDIR*BDEL
            BM4=BM3
         ELSE
C            BDEL=0.5*ABS(BM3-BM2)
            BDEL=0.5*ABS(BEYOND-BM3)
            BM4=BM3+BDIR*BDEL
         ENDIF
         DO 10 I=1,NPE
            IP = IPPTR(I)
            B(IP)=BLIM(IP)
 10      CONTINUE
         IFO=0
         GO TO 50
      ELSE
         ITERM=ITERM+1
      ENDIF
      ITRM1=ITRM1+1
      IF (IBEY.NE.0) BDEL=0.5*BDEL
C
      IF (ITERM.EQ.1) THEN
         RSQM1=RSQP
         BM2=BM1+BDEL
         BM4=BM2
         CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,NPLIST)
      ELSE IF (ITERM.EQ.2) THEN
         RSQM2=RSQP
         IF (RSQM2.GT.RSQM1) THEN
            CALL SUNC1NLI1SW(RSQM1,RSQM2,BM1,BM2)
         ELSE
            CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,NPLIST)
         ENDIF
         IF (BM2.GT.BM1) THEN
            BDIR=1.
         ELSE
            BDIR=-1.
         ENDIF
         BM3=BM2+BDIR*BDEL
         BM4=BM3
      ELSE IF (ITERM.EQ.3) THEN
         RSQM3=RSQP
         IF (RSQM3.LT.RSQM2) THEN
            CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,NPLIST)
            IF (BM3.GT.BM2) THEN
               BDIR=1.
            ELSE
               BDIR=-1.
            ENDIF
            BM4=BM3+BDIR*BDEL
         ELSE
            IF (RSQM3.LT.RSQM1) CALL SUNC1NLI1SW(RSQM1,RSQM3,BM1,BM3)
            BM4=0.5*(BM2+BM3)
         ENDIF
      ELSE
         RSQM4=RSQP
         IF (RSQM3.LT.RSQM2) THEN
            RSQM1=RSQM2
            RSQM2=RSQM3
            RSQM3=RSQM4
            BM1=BM2
            BM2=BM3
            BM3=BM4
            IF (RSQM3.LT.RSQM2) THEN
               CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,NPLIST)
               IF (BM3.GT.BM2) THEN
                  BDIR=1.
               ELSE
                  BDIR=-1.
               ENDIF
               BM4=BM3+BDIR*BDEL
            ELSE
               IF (RSQM3.LT.RSQM1) CALL SUNC1NLI1SW(RSQM1,RSQM3,BM1,BM3)
               BM4=0.5*(BM2+BM3)
            ENDIF
         ELSE IF (RSQM2.GT.RSQM4) THEN
            RSQM1=RSQM2
            RSQM2=RSQM4
            BM1=BM2
            BM2=BM4
            BM4=0.5*(BM2+BM3)
            CALL SUNC1NLI1BC(NN,BLIM,B,FLIM,FL,IPPTR,NPLIST)
         ELSE
            RSQM3=RSQM4
            BM3=BM4
            IF (RSQM3.LT.RSQM1) CALL SUNC1NLI1SW(RSQM1,RSQM3,BM1,BM3)
            BM4=0.5*(BM2+BM3)
         ENDIF
      ENDIF
C
C     CHECK CLOSURE CRITERIAS
      IFO=0
      TEMP=0.
      IF (ITERM.GT.2) THEN
         D1=ABS(RSQM1)
         IF (D1.EQ.0.) D1=ABS(RSQM3)
         IF (D1.GT.0.) TEMP=ABS(RSQM1-RSQM3)/D1
         D1=ABS(RSQM2)
         IF (D1.EQ.0.) D1=ABS(RSQM1)
         IF (D1.GT.0.) TEMP=TEMP+ABS(RSQM2-RSQM1)/D1
         IF (TEMP.LT.TOLS) IFO=2
         DTMPA=BM3-BM1
         DTMPA=DTMPA/BS(IPPTR(NPE+1))
         ADMX=DABS(DTMPA)
         IF (ADMX.LE.TOLP) IFO=1
      ENDIF
C
C     REINITIALIZE SOME PARAMETERS AND RETURN TO DO ONE MORE ITERATION
 50   IF (ITRM1.LT.ITMXP.AND.IFO.EQ.0) THEN
         B(IMAN)=BM4
         IF (LN(IMAN).GT.0) B(IMAN)=EXP(B(IMAN))
         DMX=DMAX
         AP=1.
         FAC=1.
         ADMX=10.*FCONV
         ITERP=0
         ITERPF=ITMXP
         ISTOP=0
         IUNCRW=1
         RETURN
      ENDIF
C
C     STOP MANUAL ADJUSTMENT
 100  JMAN=0
      NPE=NPE+1
      ISENS(IMAN)=-ISENS(IMAN)
C
      RETURN
      END
C=======================================================================
      SUBROUTINE UNC1NLI1CB(NPE,ND,MPR,VAR,H,WT,X,WP,LN,PRM,HOBS,C,
     &                     IBEALE,ITERPK,IOUT,OBSNAM,BUFF,NH,WTQ,
     &                     NPLIST,MPRAR,IBEFLG,OUTNAM,IUBE,BEFIRST,
     &                     IERR,IERRU,NDMHAR,WTP,IPR,IPRAR,BPRI,
     &                     NIPR,NOBS,IDOBS,IDINT,NHI,NQT,NQI,NPI,CFR,
     &                     CFI,NLIP,NLJP,WLIP,NOINT,ITYP,IDIF,ISTOP)
C-----VERSION 1001 22AUG2003 (SC)
C     MODIFIED FROM PES1BAS6BE
C     ******************************************************************
C     PRINT DATA FOR NLBEALE PROGRAM
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      REAL BUFF, H, HOBS, PRM, SB, TEMP, WP, WT, WTQ, X, CFR, CFI, WLIP, 
     &     WTP, BPRI, VG
      REAL, ALLOCATABLE :: WB(:), ZB(:,:), BUFB(:)
      INTEGER I, IBEALE, IMP, IOUT, IP, IS, ITERPK, IUBE(4), NPI, NOINT,
     &        J, LN, MPR, N, ND, NH, NPE, NDMHAR, NOBS, IDOBS, NHI, NQT, 
     &        NQI, NLIP, NLJP, I1, I2, I3, IPR, IERRU, IERR, IBEFLG,  
     &        MPRAR, NPLIST, IPRAR, NIPR, IDINT, IIPP, LENGNAM, ITYP, 
     &        IDIF, N1, ISTOP
      INTEGER IGETUNIT, NONB_LEN
      DOUBLE PRECISION C(NPE,NPE), VAR
      DIMENSION H(ND), WT(ND), X(NPE,ND), WP(MPRAR), LN(NPLIST),
     &          HOBS(ND), PRM(NPLIST+1,MPRAR), BUFF(NPE),
     &          WTP(IPRAR,IPRAR), BPRI(IPRAR),NIPR(IPRAR),IDOBS(NOBS),
     &          IDINT(NOINT),NLIP(NPI),NLJP(NPI),WLIP(NPI),CFI(NOINT)
      DIMENSION WTQ(NDMHAR,NDMHAR)
      CHARACTER*4 CHAR, SUF(4)
      CHARACTER*12 OBSNAM(ND)
      CHARACTER*200 OUTNAM
      CHARACTER*84 FN(4)
      LOGICAL BEFIRST, LOP
      INCLUDE 'param.inc'
      DATA (SUF(I),I=1,4)/'._b1','._b2','._b3','._b4'/
C     ------------------------------------------------------------------
C
  500 FORMAT (8G15.8)
  505 FORMAT (8G13.6)
  510 FORMAT (5I10,2(1X,G13.6))
  515 FORMAT (' THE PARAMETER SETS FOLLOW')
  520 FORMAT (6G13.6)
  525 FORMAT (8I10)
  530 FORMAT (20A4)
  535 FORMAT (8F13.0)
  540 FORMAT (//,
     &        ' PARAMETER SETS NOT FOUND IN ',A,/,' -- STOP EXECUTION')
  550 FORMAT (6(A12,1X))
  560 FORMAT (1X,'ERROR FINDING AVAILABLE FILE UNIT -- STOP',
     &' EXECUTION (UNC1NLI1CB)')
  570 FORMAT (1X,'ERROR OPENING FILE ON UNIT ',I5,' FOR BEALE2',
     &' INPUT',/' TRYING TO OPEN FILE: "',A,'"'/,
     &' -- STOP EXECUTION (UNC1NLI1CB)')
  580 FORMAT (6(A10,1X))
C
      IF (OUTNAM.EQ.'NONE') RETURN
C-----OPEN FILE(S) FOR NLBEALE INPUT
      IF (BEFIRST) THEN
         DO 8 J = 1, IBEFLG
            DO 7 I = J, J+2, +2 
               IUBE(I) = IGETUNIT(1,1000)
               LENGNAM = NONB_LEN(OUTNAM,200)
               FN(I) = OUTNAM(1:LENGNAM)//SUF(I)
               IF (IUBE(I).GT.0) THEN
                  OPEN(IUBE(I),FILE=FN(I),ERR=4)
                  IF (IBEFLG.EQ.1) THEN
                     INQUIRE(UNIT=IUBE(I),OPENED=LOP)
                     IF (LOP) CLOSE(UNIT=IUBE(I),STATUS='DELETE')
                     OPEN(IUBE(I),FILE=FN(I),ERR=4)
                  ENDIF
               ELSE
                  WRITE(IOUT,560)
                  WRITE(IERRU,560)
                  IERR = 1
                  RETURN
               ENDIF
               GOTO 6
    4          CONTINUE
               IF (I.GT.2.AND.NOINT.LT.1) GOTO 6
               WRITE (IOUT,570) IUBE(I),FN(I)
               WRITE (IERRU,570) IUBE(I),FN(I)
               IERR = 1
               RETURN
    6          CONTINUE
    7       CONTINUE
    8    CONTINUE
         BEFIRST = .FALSE.
      ENDIF
C
      IBEALE = 0
      IF (IBEFLG.EQ.1) THEN
C        WRITE ITEM 1 OF _b1 FILE
         WRITE (IUBE(1),510) NPE, NOBS, NQT-NQI, MPR, IPR, VAR, CFR
         DO 10 IP = 1, NPE
            IIPP = IPPTR(IP)
            IF (LN(IIPP).GT.0) B(IIPP) = EXP(B(IIPP))
   10    CONTINUE
C        WRITE ITEMS 2 AND 3 OF _b1 FILE
         WRITE (IUBE(1),580) (PARNAM(IPPTR(IP)),IP=1,NPE)
         WRITE (IUBE(1),520) (B(IPPTR(IP)),IP=1,NPE)
         DO 20 IP = 1, NPE
            IIPP = IPPTR(IP)
            IF (LN(IIPP).GT.0) B(IIPP) = LOG(B(IIPP))
   20    CONTINUE
C        WRITE ITEMS 4-7 OF _b1 FILE
         WRITE (IUBE(1),550) (OBSNAM(IDOBS(N)),N=1,NOBS)
         WRITE (IUBE(1),520) (H(IDOBS(N)),N=1,NOBS)
         WRITE (IUBE(1),520) (HOBS(IDOBS(N)),N=1,NOBS)
         N=NH-NHI
         IF (N.GT.0) WRITE (IUBE(1),500) (WT(I),I=1,N)
         IF (N.LT.NOBS) THEN
            N=N+1
            DO 30 I = N, NOBS
C              WRITE ITEM 8 OF _b1 FILE
               I1=IDOBS(I)-NH
               WRITE (IUBE(1),500) (WTQ(I1,IDOBS(J)-NH),J=N,NOBS)
   30       CONTINUE
         ENDIF
         DO 40 N = 1, NOBS
C           WRITE ITEM 9 OF _b1 FILE
            WRITE (IUBE(1),520) (X(IP,IDOBS(N)),IP=1,NPE)
   40    CONTINUE
         IF (MPR.GT.0) THEN
            DO 50 IMP = 1, MPR
C              WRITE ITEM 10 OF _b1 FILE
               WRITE (IUBE(1),500) (PRM(IPPTR(IP),IMP),IP=1,NPE),
     &                       PRM(NPLIST+1,IMP), WP(IMP)
   50       CONTINUE
         ENDIF
         IF (IPR.GT.0) THEN
C           WRITE ITEM 11 AND FIRST ITEM 12 OF _b1 FILE
            WRITE (IUBE(1),525) (NIPR(I),I=1,IPR)
            WRITE (IUBE(1),505) (BPRI(I),I=1,IPR)
            DO 55 I = 1, IPR
C              WRITE SECOND ITEM 12 OF _b1 FILE
               WRITE (IUBE(1),505) (WTP(I,J),J=1,IPR)
   55       CONTINUE
         ENDIF
C        WRITE ITEM 13 OF _b1 FILE
         WRITE (IUBE(1),525) (LN(IPPTR(IP)),IP=1,NPE)
C         CALCULATE PARAMETER SETS
         WRITE (IUBE(1),515)
         TEMP = (REAL(NPE)*CFR)**.5
         DO 80 IP = 1, NPE
            SB = C(IP,IP)**.5
            DO 70 IS = -1, 1, 2
               DO 60 I = 1, NPE
                  IIPP = IPPTR(I)
                  BUFF(I) = B(IIPP) + REAL(IS)*(TEMP/SB)*C(IP,I)
                  IF (LN(IIPP).GT.0) BUFF(I) = EXP(BUFF(I))
   60          CONTINUE
C              WRITE ITEM 14 OF _b1 FILE
               WRITE (IUBE(1),505) (BUFF(I),I=1,NPE)
   70       CONTINUE
   80    CONTINUE
C
C        WRITE ITEMS OF _b3 FILE (FOR INTERVALS)
         IF (NOINT.GT.0) THEN
C
            ALLOCATE(WB(NOINT),ZB(NPE,NOINT),BUFB(NPE))
            N=NHI+NQI
C
            IF (IDIF.LT.1) THEN
               N1=NOINT
               WRITE(IUBE(3),'(6I10)') NOINT, NHI, NQI, NPI, ITYP, IDIF
               WRITE(IUBE(3),550) (OBSNAM(IDINT(I)),I=1,N), 
     :                            (PARNAM(NLIP(I)),I=1,NPI)
               WRITE(IUBE(3),520) (H(IDINT(I)),I=1,N),
     :                            (B(NLIP(I)),I=1,NPI)
C               WRITE(IUBE(3),500) (WT(IDINT(I)),I=1,NHI), 
C     :                            (WTQ(IDINT(I)-NH,IDINT(I)-NH),
C     :                            I=NHI+1,NHI+NQI), 
C     :                            (WLIP(I),I=1,NPI)
C               DO 90 I=1,N
C                  WRITE(IUBE(3),520) (X(IP,IDINT(I)),IP=1,NPE)
C   90          CONTINUE
               DO I=1,NHI
                  WB(I)=WT(IDINT(I))
               END DO
               DO I=NHI+1,N
                  WB(I)=WTQ(IDINT(I)-NH,IDINT(I)-NH)
               END DO
               DO I=1,NPI
                  IF (WLIP(I).LE.0.) THEN
                     WB(N+I)=0.
                  ELSE   
                     WB(N+I)=SQRT(1./WLIP(I))
                  END IF   
               END DO
               DO I=1,N
                  DO IP=1,NPE 
                     ZB(IP,I)=X(IP,IDINT(I))
                  END DO
               END DO
               DO I=1,NPI 
                  DO IP=1,NPE 
                     ZB(IP,N+I)=0.
                  END DO
                  ZB(NLJP(I),N+I)=1.
               END DO
            ELSE
               N1=(NHI+NQI)/2+NPI
               WRITE(IUBE(3),'(6I10)') N1, NHI/2, NQI/2, NPI, ITYP, IDIF
               WRITE(IUBE(3),550) (OBSNAM(IDINT(I)),I=1,N,2),
     :                            (PARNAM(NLIP(I)),I=1,NPI)
               WRITE(IUBE(3),520) (H(IDINT(I))-H(IDINT(I+1)),I=1,N,2),
     :                            (B(NLIP(I)),I=1,NPI)
               J=0
               DO I=1,NHI,2
                  J=J+1
                  WB(J)=1./( 1./WT(IDINT(I))+1./WT(IDINT(I+1)) )
               END DO
               DO I=NHI+1,N,2
                  J=J+1
                  WB(J)=1./( 1./WTQ(IDINT(I)-NH,IDINT(I)-NH) + 
     :                       1./WTQ(IDINT(I+1)-NH,IDINT(I+1)-NH) )
               END DO
               DO I=1,NPI
                  J=J+1
                  IF (WLIP(I).LE.0.) THEN
                     WB(J)=0.
                  ELSE   
                     WB(J)=SQRT(1./WLIP(I))
                  END IF   
               END DO
               J=0
               DO I=1,N,2
                  J=J+1
                  DO IP=1,NPE 
                     ZB(IP,J)=X(IP,IDINT(I))-X(IP,IDINT(I+1))
                  END DO
               END DO
               DO I=1,NPI 
                  J=J+1
                  DO IP=1,NPE 
                     ZB(IP,J)=0.
                  END DO
                  ZB(NLJP(I),J)=1.
               END DO
            END IF
            WRITE(IUBE(3),500) (WB(I),I=1,N1)
            DO 90 I=1,N1
               WRITE(IUBE(3),520) (ZB(IP,I),IP=1,NPE)
 90         CONTINUE           
C           CORRECTION FACTORS AND PARAMETER SETS
            WRITE(IUBE(3),'(6(1X,G13.6))') (CFI(I),I=1,N1)
            WRITE (IUBE(3),515)
            DO I=1,N1
               DO IP=1,NPE
                  BUFB(IP)=0.
                  DO J=1,NPE
                     BUFB(IP)=BUFB(IP)+C(IP,J)*ZB(J,I)
                  END DO
               END DO
               VG=0.
               DO IP=1,NPE
                  VG=VG+BUFB(IP)*ZB(IP,I)
               END DO
               IF (ITYP.EQ.2) VG=VG+1./WB(I)
               TEMP=(CFI(I)/VG)**.5
               DO IS=-1,1,2 
                  DO IP=1, NPE
                     IIPP=IPPTR(IP)
                     BUFF(IP)=B(IIPP)+REAL(IS)*TEMP*BUFB(IP)
                     IF (LN(IIPP).GT.0) BUFF(IP)=EXP(BUFF(IP))
                  END DO
                  WRITE(IUBE(3),505) (BUFF(IP),IP=1,NPE)
               END DO
            END DO
            DEALLOCATE(WB,ZB,BUFB)
         END IF   
C   
      ELSE
C       IBEFLG MUST EQUAL 2
         IF (ITERPK.EQ.1) THEN
            DO 190 I = 1, 100000000
               READ (IUBE(1),530) CHAR
               IF (CHAR.EQ.' THE') GOTO 200
  190       CONTINUE
            WRITE (IOUT,540) FN(1)
            WRITE (IERRU,540) FN(1)
            STOP
  200       IF (IDIF.LT.1) THEN
               N1=NOINT
            ELSE
               N1=(NHI+NQI)/2+NPI
            END IF
            IF (N1.GT.0) THEN
               I1=0
               I2=1
               I3=1
               DO 210 I = 1, 100000000
                  READ (IUBE(3),530) CHAR
                  IF (CHAR.EQ.' THE') GOTO 220
  210          CONTINUE
               WRITE (IOUT,540) FN(3)
               WRITE (IERRU,540) FN(3)
               STOP
            END IF   
         ENDIF
  220    IF (ITERPK.GT.(2*NPE)+1) THEN
            I1=I1+1
            IF (I2.GT.NHI+NQI) THEN
               IIPP=NLIP(I3)
               TEMP=B(IIPP)
               IF (LN(IIPP).GT.0) TEMP=LOG(TEMP)
               IF (MOD(I1,2).EQ.0) I3=I3+1
            ELSE IF (IDIF.LT.1) THEN
               TEMP=H(IDINT(I2))
               IF (MOD(I1,2).EQ.0) I2=I2+1
            ELSE
               TEMP=H(IDINT(I2))-H(IDINT(I2+1))
               IF (MOD(I1,2).EQ.0) I2=I2+2
            END IF
            WRITE(IUBE(4),505) (B(IPPTR(IP)),IP=1,NPE)
            WRITE(IUBE(4),520) (H(IDOBS(N)),N=1,NOBS)
            WRITE(IUBE(4),520) TEMP
         ELSE IF (ITERPK.GT.1) THEN
            WRITE(IUBE(2),505) (B(IPPTR(IP)),IP=1,NPE)
            WRITE(IUBE(2),520) (H(IDOBS(N)),N=1,NOBS)
         ENDIF
         IF (ITERPK.LT.(2*NPE)+1) THEN
            READ (IUBE(1),535) (B(IPPTR(IP)),IP=1,NPE)
            IBEALE = 1
         ELSE IF (ITERPK.LT.2*(NPE+N1)+1) THEN
            READ (IUBE(3),535) (B(IPPTR(IP)),IP=1,NPE)
            IBEALE = 1
         ENDIF
      ENDIF
      RETURN
      END
C=======================================================================C
      SUBROUTINE UNC1NLI1CF(NPE,ND,MPR,VAR,WT,X,WP,PRM,
     &                     IBEALE,IOUT,OBSNAM,NH,WTQ,
     &                     NPLIST,MPRAR,OUTNAM,IUBE,
     &                     IERR,IERRU,NDMHAR,IPR,IPRAR,
     &                     NIPR,NOBS,IDOBS,IDINT,NHI,NQT,NQI,NPI,
     &                     NLIP,NLJP,WLIP,NOINT,ITYP,IDIF,
     &                     WTQS,WTPS)
C-----VERSION 1001 22AUG2003 (SC)
C     MODIFIED FROM PES1BAS6BE
C     ******************************************************************
C     PRINT DATA FOR CORFAC PROGRAM
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      REAL PRM, WP, WT, WTQ, X, WLIP, WTQS, WTPS, TMP
      REAL, ALLOCATABLE :: WB(:), ZB(:,:), BUFB(:)
      INTEGER I, IBEALE, IMP, IOUT, IP, IUBE, NPI, NOINT,
     &        J, MPR, N, ND, NH, NPE, NDMHAR, NOBS, IDOBS, NHI, NQT, 
     &        NQI, NLIP, NLJP, I1, IPR, IERRU, IERR, 
     &        MPRAR, NPLIST, IPRAR, NIPR, IDINT, LENGNAM, ITYP, 
     &        IDIF, N1
      INTEGER IGETUNIT, NONB_LEN
C      DOUBLE PRECISION C(NPE,NPE), VAR
      DOUBLE PRECISION VAR
      DIMENSION WT(ND), X(NPE,ND), WP(MPRAR), IUBE(1),
     &          PRM(NPLIST+1,MPRAR),
     &          NIPR(IPRAR),IDOBS(NOBS),
     &          IDINT(NOINT),NLIP(NPI),NLJP(NPI),WLIP(NPI)
      DIMENSION WTQ(NDMHAR,NDMHAR),WTQS(NDMHAR,NDMHAR),WTPS(IPRAR,IPRAR)
      CHARACTER*4 SUF(1)
      CHARACTER*12 OBSNAM(ND)
      CHARACTER*200 OUTNAM
      CHARACTER*84 FN(4)
      LOGICAL LOP
      INCLUDE 'param.inc'
      DATA (SUF(I),I=1,1)/'._cf'/
C     ------------------------------------------------------------------
C
  500 FORMAT (8G15.8)
  505 FORMAT (8G13.6)
  510 FORMAT (5I10,2(1X,G13.6))
  515 FORMAT (' THE PARAMETER SETS FOLLOW')
  520 FORMAT (6G13.6)
  525 FORMAT (8I10)
  530 FORMAT (20A4)
  535 FORMAT (8F13.0)
  540 FORMAT (//,
     &        ' PARAMETER SETS NOT FOUND IN ',A,/,' -- STOP EXECUTION')
  550 FORMAT (6(A12,1X))
  560 FORMAT (1X,'ERROR FINDING AVAILABLE FILE UNIT -- STOP',
     &' EXECUTION (UNC1NLI1CF)')
  570 FORMAT (1X,'ERROR OPENING FILE ON UNIT ',I5,' FOR CORFAC',
     &' INPUT',/' TRYING TO OPEN FILE: "',A,'"'/,
     &' -- STOP EXECUTION (UNC1NLI1CF)')
  580 FORMAT (6(A10,1X))
C
      IF (OUTNAM.EQ.'NONE') RETURN
C-----OPEN FILE FOR CORFAC INPUT
      I = 1
      IUBE(I) = IGETUNIT(1,1000)
      LENGNAM = NONB_LEN(OUTNAM,200)
      FN(I) = OUTNAM(1:LENGNAM)//SUF(I)
      IF (IUBE(I).GT.0) THEN
         OPEN(IUBE(I),FILE=FN(I),ERR=4)
C         IF (IBEFLG.EQ.1) THEN
         INQUIRE(UNIT=IUBE(I),OPENED=LOP)
         IF (LOP) CLOSE(UNIT=IUBE(I),STATUS='DELETE')
         OPEN(IUBE(I),FILE=FN(I),ERR=4)
C         ENDIF
      ELSE
         WRITE(IOUT,560)
         WRITE(IERRU,560)
         IERR = 1
         RETURN
      ENDIF
      GOTO 6
    4 CONTINUE
      IF (I.GT.2.AND.NOINT.LT.1) GOTO 6
      WRITE (IOUT,570) IUBE(I),FN(I)
      WRITE (IERRU,570) IUBE(I),FN(I)
      IERR = 1
      RETURN
    6 CONTINUE
C
C     WRITE ITEM 1 OF _b1 FILE
      TMP = -1.0
      WRITE (IUBE(1),510) NPE, NOBS, NQT-NQI, MPR, IPR, VAR, TMP
      WRITE (IUBE(1),580) (PARNAM(IPPTR(IP)),IP=1,NPE)
C     WRITE SQUARE-ROOT OF WEIGHTS FOR MODEL FUNCTIONS
      WRITE (IUBE(1),550) (OBSNAM(IDOBS(N)),N=1,NOBS)
      N=NH-NHI
      IF (N.GT.0) WRITE (IUBE(1),500) (SQRT(WT(I)),I=1,N)
      IF (N.LT.NOBS) THEN
         N=N+1
         DO 30 I = N, NOBS
C           WRITE ITEM 8 OF _b1 FILE
            I1=IDOBS(I)-NH
            WRITE (IUBE(1),500) (WTQS(I1,IDOBS(J)-NH),J=N,NOBS)
   30    CONTINUE
      ENDIF
C     WRITE SENSITIVITIES FOR MODEL FUNCTIONS
      DO 40 N = 1, NOBS
         WRITE (IUBE(1),520) (X(IP,IDOBS(N)),IP=1,NPE)
   40 CONTINUE
C     WRITE SENSITIVITIES AND SQUARE-ROOT WEIGHT FOR PRIOR-INF. EQ.
      IF (MPR.GT.0) THEN
         DO 50 IMP = 1, MPR
C           WRITE ITEM 10 OF _b1 FILE
            WRITE (IUBE(1),500) (PRM(IPPTR(IP),IMP),IP=1,NPE),
     &                           SQRT(WP(IMP))
   50    CONTINUE
      ENDIF
C     WRITE NUMBERS AND SQUARE-ROOT WEIGHT FOR CORRELATED PRIOR INF.
      IF (IPR.GT.0) THEN
         WRITE (IUBE(1),525) (NIPR(I),I=1,IPR)
         DO 55 I = 1, IPR
            WRITE (IUBE(1),505) (WTPS(I,J),J=1,IPR)
   55    CONTINUE
      ENDIF
C
C     WRITE ITEMS FOR INTERVALS
      IF (NOINT.GT.0) THEN
C
         ALLOCATE(WB(NOINT),ZB(NPE,NOINT),BUFB(NPE))
         N=NHI+NQI
C
         IF (IDIF.LT.1) THEN
            N1=NOINT
            WRITE(IUBE(1),'(6I10)') NOINT, NHI, NQI, NPI, ITYP, IDIF
            WRITE(IUBE(1),550) (OBSNAM(IDINT(I)),I=1,N), 
     :                         (PARNAM(NLIP(I)),I=1,NPI)
            DO I=1,NHI
               WB(I)=SQRT(WT(IDINT(I)))
            END DO
            DO I=NHI+1,N
               WB(I)=SQRT(WTQ(IDINT(I)-NH,IDINT(I)-NH))
            END DO
            DO I=1,NPI
               IF (WLIP(I).LE.0.) THEN
                  WB(N+I)=0.
               ELSE   
                  WB(N+I)=SQRT(1./WLIP(I))
               END IF   
            END DO
            DO I=1,N
               DO IP=1,NPE 
                  ZB(IP,I)=X(IP,IDINT(I))
               END DO
            END DO
            DO I=1,NPI 
               DO IP=1,NPE 
                  ZB(IP,N+I)=0.
               END DO
               ZB(NLJP(I),N+I)=1.
            END DO
         ELSE
            N1=(NHI+NQI)/2+NPI
            WRITE(IUBE(1),'(6I10)') N1, NHI/2, NQI/2, NPI, ITYP, IDIF
            WRITE(IUBE(1),550) (OBSNAM(IDINT(I)),I=1,N,2),
     :                         (PARNAM(NLIP(I)),I=1,NPI)
            J=0
            DO I=1,NHI,2
               J=J+1
               WB(J)=SQRT(1./( 1./WT(IDINT(I))+1./WT(IDINT(I+1)) ))
            END DO
            DO I=NHI+1,N,2
               J=J+1
               WB(J)=SQRT(1./( 1./WTQ(IDINT(I)-NH,IDINT(I)-NH) + 
     :                    1./WTQ(IDINT(I+1)-NH,IDINT(I+1)-NH) ))
            END DO
            DO I=1,NPI
               J=J+1
               IF (WLIP(I).LE.0.) THEN
                  WB(J)=0.
               ELSE   
                  WB(J)=SQRT(1./WLIP(I))
               END IF   
            END DO
            J=0
            DO I=1,N,2
               J=J+1
               DO IP=1,NPE 
                  ZB(IP,J)=X(IP,IDINT(I))-X(IP,IDINT(I+1))
               END DO
            END DO
            DO I=1,NPI 
               J=J+1
               DO IP=1,NPE 
                  ZB(IP,J)=0.
               END DO
               ZB(NLJP(I),J)=1.
            END DO
         END IF
C        WRITE WEIGHTS 
         WRITE(IUBE(1),500) (WB(I),I=1,N1)
C        WRITE SENSITIVITIES 
         DO 90 I=1,N1
            WRITE(IUBE(1),520) (ZB(IP,I),IP=1,NPE)
 90      CONTINUE
C
         DEALLOCATE(WB,ZB,BUFB)
      END IF
      IBEALE = 1
C   
      RETURN
      END
C=======================================================================
      SUBROUTINE SUNC1NLI1BC(NPE,A,B,RA,RB,IPPTR,NPLIST)
C-----VERSION 1001 25FEB2003 (SC)
C     ******************************************************************
      INTEGER NPE,IPPTR,NPLIST,I,IP
      REAL A,B,RA,RB
      DIMENSION A(NPLIST),B(NPLIST),IPPTR(NPLIST)
C     ------------------------------------------------------------------
C
      DO 10 I=1,NPE
         IP = IPPTR(I)
         A(IP)=B(IP)
 10   CONTINUE
      RA=RB
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE SUNC1NLI1SW(A1,A2,B1,B2)
C-----VERSION 1001 25FEB2003 (SC)
C     ******************************************************************
      REAL A1,A2,B1,B2,DUM
C     ------------------------------------------------------------------
C
      DUM=A1
      A1=A2
      A2=DUM
      DUM=B1
      B1=B2
      B2=DUM
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE SUNC1NLI1FI(NAM,VQ,N1,NOINT,NQI,IDIF,IERR,IOUT)
C     VERSION 1001 15MAR2002 (SC)
C     ******************************************************************
C     CHECK NUMBER OF INTERVALS ON FLOW OR FLOW DIFFERENCES FOR A 
C     PACKAGE
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INTEGER N,N1,NOINT,NQI,IDIF,IERR,IOUT
      CHARACTER*3 NAM
      CHARACTER*5 VQ
C     ------------------------------------------------------------------
 130  FORMAT(' ERROR! ',A,' MUST BE AN EQUAL NUMBER FOR IDIF=1; ',
     &       'INPUT IS ',A,'=',I4)
 140  FORMAT(
     &' NUMBER OF ',A,'-FLOW-DIFFERENCE INTERVALS................:',I5)
 150  FORMAT(                                                 
     &' NUMBER OF ',A,'-FLOW INTERVALS...........................:',I5)
C
      IF (N1.GT.0) THEN
        IF (IDIF.NE.0) THEN
          N = N1/2
          IF (N+N.NE.N1) THEN
            WRITE(IOUT,130) VQ,VQ,N1
            IERR = 1
          ELSE
            WRITE(IOUT,140) NAM,N
          END IF
        ELSE
          WRITE(IOUT,150) NAM,N1
          N = N1
        ENDIF
      ELSE
        N1 = 0
        N = N1
      END IF
      NOINT = NOINT+N
      NQI = NQI+N1
C
      RETURN
      END
C=======================================================================
C
      SUBROUTINE SUNC1NLI1ID(IINT,NOINT,N,NI,IDINT,N0,IDOBS,NOBS,IOBS)
C     VERSION 1001 12APR2002 (SC)
C     ******************************************************************
C     SETS ID OF HEAD AND FLOW INTERVAL VARIABLES AND OBSERVATIONS
C     ******************************************************************
C     SPECIFICATIONS:
C     ------------------------------------------------------------------
      INTEGER IINT,NOINT,N,NI,IDINT,I,IDOBS,NOBS,N0,IOBS
      DIMENSION IDINT(NOINT),IDOBS(NOBS)
C     ------------------------------------------------------------------
      IF (N0.LE.N) THEN
         DO 5 I=N0,N
             IOBS=IOBS+1
             IDOBS(IOBS)=I
    5    CONTINUE
      ENDIF
      IF (NI.GT.0) THEN
         DO 10 I=1,NI
           N = N+1
           IINT = IINT+1
           IDINT(IINT) = N
   10    CONTINUE
      ENDIF
C
      RETURN
      END
C=======================================================================
      SUBROUTINE SUNC1NLI1WF(NPE,N1,N2,NH,WTQ,WTQS,X,C,G,HOBS,H,
     &                       IOWTQ,NDMHAR,RSQP,OBSNAM,UGUZ,U,IWRP)
C-----VERSION 1001 18JUNE2003 (SC)
C     ******************************************************************
C     FOR DATA WITH FULL WEIGHT MATRIX: ADD SENSITIVITY CONTRIBUTIONS 
C     TO C AND G AND ADD TO RSQP (SUM OF SQUARED ERRORS), OR IF IWRP < 0
C     RECALCULATE G, OR IF IWRP > 0 COMPUTE AND PRINT WEIGHTED RESIDUALS
C     ******************************************************************
C        SPECIFICATIONS:
C     ------------------------------------------------------------------
      REAL H, HOBS, TMPA, W, WTQ, WTQS, X, RSQP, WTR, TMPB
      INTEGER I, IOWTQ, IP, J, K, L, L1, N1, N2, NH, NPE, 
     &        NDMHAR,IWRP, N
      DOUBLE PRECISION C(NPE,NPE), G(NPE), DTMPA, TMP, UGUZ, U(NPE)
      DIMENSION WTQ(NDMHAR,NDMHAR), X(NPE,NH+NDMHAR), HOBS(NH+NDMHAR),
     &          H(NH+NDMHAR), WTQS(NDMHAR,NDMHAR)
      CHARACTER*12 OBSNAM(NH+NDMHAR)
C     ------------------------------------------------------------------
C
      IF (IWRP.GT.0) GOTO 200
C
C-------ADD CONTRIBUTION TO C, G, AND RSQP
      IF (IOWTQ.GT.0) THEN
C       ADD TO COEFFICIENT MATRIX, C
        IF (IWRP.EQ.0) THEN
          DO 50 J = 1, NPE
            DO 40 K = N1, N2
              TMP = 0.0
              IF (WTQ(K,K).GT.0.0) THEN
                DO 20 L = N1, N2
                  IF (WTQ(L,L).GT.0.0) THEN
                    TMP = TMP + DBLE(WTQ(K,L))*DBLE(X(J,NH+L))
                  ENDIF
   20           CONTINUE
              ENDIF
              DO 30 I = J, NPE
                C(I,J) = C(I,J) + DBLE(X(I,NH+K))*TMP
   30         CONTINUE
   40       CONTINUE
   50     CONTINUE
        ENDIF
C       ADD TO GRADIENT VECTOR, G
        DO 90 I = 1, NPE
          DO 80 K = N1, N2
            TMP = 0.0
            IF (WTQ(K,K).GT.0.0) THEN
              DO 70 L = N1, N2
                L1 = NH + L
                IF (WTQ(L,L).GT.0.0) THEN
                  TMP = TMP + DBLE(WTQ(K,L))*DBLE(HOBS(L1)-H(L1))
                ENDIF
   70         CONTINUE
            ENDIF
            G(I) = G(I) + DBLE(X(I,NH+K))*TMP
   80     CONTINUE
   90   CONTINUE
C       ADD TO RSQP
        IF (IWRP.EQ.0) THEN
          DO 110 K = N1, N2
            IF (WTQ(K,K).GT.0.) THEN
               WTR = 0.0
               DO 100 L = N1, N2
                 IF (WTQ(L,L).GT.0.) THEN
                    L1 = NH + L
                    WTR = WTR + WTQS(K,L)*(HOBS(L1)-H(L1))
                 ENDIF
  100          CONTINUE
               RSQP = RSQP + WTR**2
            ENDIF
  110     CONTINUE
        ENDIF
      ELSE
C
C     IF WEIGHT MATRIX IS DIAGONAL
        DO 140 L = N1, N2
          L1 = L + NH
          TMPA = HOBS(L1) - H(L1)
          W = WTQ(L,L)
          IF (W.LT.0) THEN
            W = 1.E-20
          ELSE IF (IWRP.EQ.0) THEN
            RSQP = RSQP + W*TMPA**2
          ENDIF
          DO 130 IP = 1, NPE
            DTMPA = DBLE(W)*DBLE(X(IP,L1))
            IF (IWRP.EQ.0) THEN
              DO 120 I = IP, NPE
                C(I,IP) = DBLE(X(I,L1))*DTMPA + C(I,IP)
  120         CONTINUE
            ENDIF
            G(IP) = DTMPA*TMPA + G(IP)
  130     CONTINUE
  140   CONTINUE
      ENDIF
C      
      RETURN
C      
C-------COMPUTE AND PRINT WEIGHTED RESIDUALS 
  200 IF (IOWTQ.GT.0) THEN
         DO 230 K=N1,N2
            N = NH + K
            IF (WTQ(K,K).LT.0.0) THEN
               WRITE(IWRP,300) N, OBSNAM(N)
            ELSE
               WTR = 0.0
               TMPB = 0.0
               DO 220 L=N1,N2
                  IF (WTQ(L,L).GT.0.0) THEN
                     L1 = L + NH
                     TMPA = 0.0 
                     DO 210 I=1,NPE
                        TMPA = TMPA + X(I,L1)*U(I)
  210                CONTINUE
                     W = WTQS(K,L)
                     WTR = WTR - W*TMPA
                     TMPB = TMPB + W*(HOBS(L1) - H(L1))
                  END IF    
  220          CONTINUE
               WTR = WTR*UGUZ + TMPB
               WRITE(IWRP,310) N, OBSNAM(N), WTR
            END IF    
  230    CONTINUE
      ELSE
         DO 250 L = N1, N2
            L1 = L + NH
            IF (WTQ(L,L).LT.0.0) THEN
               WRITE(IWRP,300) L1, OBSNAM(L1)
            ELSE
               TMPA = 0.0 
               DO 240 I = 1, NPE
                  TMPA = TMPA + X(I,L1)*U(I)
  240          CONTINUE
               WTR=WTQS(L,L)*(HOBS(L1) - H(L1) - TMPA*UGUZ)
               WRITE(IWRP,310) L1, OBSNAM(L1), WTR
            ENDIF
  250    CONTINUE
      ENDIF
      RETURN
C      
  300 FORMAT (1X,I5,1X,A12,2X,'DISCONNECTED')
  310 FORMAT (1X,I5,1X,A12,2X,G10.3)
C      
      END
C=======================================================================

